;*** SetAsmDefinitions.asm ***;
;-------------------------------------------------
 .def R_DATA_LOW   = R0
 .def R_DATA_HIGH  = R1
 .def R_SP_LOW     = R6
 .def R_SP_HIGH    = R7
 .def R_PARAM_LOW  = R10
 .def R_PARAM_HIGH = R11
 .def R_TEMP_LOW   = R22
 .def R_TEMP_HIGH  = R23
 .def R_COUNT_LOW  = R24
 .def R_COUNT_HIGH = R25
 .def R_XP_LOW     = R26
 .def R_XP_HIGH    = R27
 .def R_ZP_LOW     = R30
 .def R_ZP_HIGH    = R31
;-------------------------------------------------
 .ifdef TagSetAsmDefinitions32

;***** THIS IS A MACHINE GENERATED FILE - DO NOT EDIT ********************
;***** Created: 2009-11-03 14:40 ******* Source: ATmega32.xml ************
;*************************************************************************
;* A P P L I C A T I O N   N O T E   F O R   T H E   A V R   F A M I L Y
;*
;* Number            : AVR000
;* File Name         : "m32def.inc"
;* Title             : Register/Bit Definitions for the ATmega32
;* Date              : 2009-11-03
;* Version           : 2.35
;* Support E-mail    : avr@atmel.com
;* Target MCU        : ATmega32
;*
;* DESCRIPTION
;* When including this file in the assembly program file, all I/O register
;* names and I/O register bit names appearing in the data book can be used.
;* In addition, the six registers forming the three data pointers X, Y and
;* Z have been assigned names XL - ZH. Highest RAM address for Internal
;* SRAM is also defined
;*
;* The Register names are represented by their hexadecimal address.
;*
;* The Register Bit names are represented by their bit number (0-7).
;*
;* Please observe the difference in using the bit names with instructions
;* such as "sbr"/"cbr" (set/clear bit in register) and "sbrs"/"sbrc"
;* (skip if bit in register set/cleared). The following example illustrates
;* this:
;*
;* in    r16,PORTB             ;read PORTB latch
;* sbr   r16,(1<<PB6)+(1<<PB5) ;set PB6 and PB5 (use masks, not bit#)
;* out   PORTB,r16             ;output to PORTB
;*
;* in    r16,TIFR              ;read the Timer Interrupt Flag Register
;* sbrc  r16,TOV0              ;test the overflow flag (use bit#)
;* rjmp  TOV0_is_set           ;jump if set
;* ...                         ;otherwise do something else
;*************************************************************************

;#ifndef _M32DEF_INC_
;#define _M32DEF_INC_


;#pragma partinc 0

; ***** SPECIFY DEVICE ***************************************************
;.device ATmega32
;#pragma AVRPART ADMIN PART_NAME ATmega32
 .equ SIGNATURE_000 = 0x1e
 .equ SIGNATURE_001 = 0x95
 .equ SIGNATURE_002 = 0x02

;#pragma AVRPART CORE CORE_VERSION V2E


; ***** I/O REGISTER DEFINITIONS *****************************************
; NOTE:
; Definitions marked "MEMORY MAPPED"are extended I/O ports
; and cannot be used with IN/OUT instructions
 .equ SREG = 0x3f
 .equ SPL = 0x3d
 .equ SPH = 0x3e
 .equ OCR0 = 0x3c
 .equ GICR = 0x3b
 .equ GIFR = 0x3a
 .equ TIMSK = 0x39
 .equ TIFR = 0x38
 .equ SPMCR = 0x37
 .equ TWCR = 0x36
 .equ MCUCR = 0x35
 .equ MCUCSR = 0x34
 .equ TCCR0 = 0x33
 .equ TCNT0 = 0x32
 .equ OSCCAL = 0x31
 .equ OCDR = 0x31
 .equ SFIOR = 0x30
 .equ TCCR1A = 0x2f
 .equ TCCR1B = 0x2e
 .equ TCNT1L = 0x2c
 .equ TCNT1H = 0x2d
 .equ OCR1AL = 0x2a
 .equ OCR1AH = 0x2b
 .equ OCR1BL = 0x28
 .equ OCR1BH = 0x29
 .equ ICR1L = 0x26
 .equ ICR1H = 0x27
 .equ TCCR2 = 0x25
 .equ TCNT2 = 0x24
 .equ OCR2 = 0x23
 .equ ASSR = 0x22
 .equ WDTCR = 0x21
 .equ UBRRH = 0x20
 .equ UCSRC = 0x20
 .equ EEARL = 0x1e
 .equ EEARH = 0x1f
 .equ EEDR = 0x1d
 .equ EECR = 0x1c
 .equ PORTA = 0x1b
 .equ DDRA = 0x1a
 .equ PINA = 0x19
 .equ PORTB = 0x18
 .equ DDRB = 0x17
 .equ PINB = 0x16
 .equ PORTC = 0x15
 .equ DDRC = 0x14
 .equ PINC = 0x13
 .equ PORTD = 0x12
 .equ DDRD = 0x11
 .equ PIND = 0x10
 .equ SPDR = 0x0f
 .equ SPSR = 0x0e
 .equ SPCR = 0x0d
 .equ UDR = 0x0c
 .equ UCSRA = 0x0b
 .equ UCSRB = 0x0a
 .equ UBRRL = 0x09
 .equ ACSR = 0x08
 .equ ADMUX = 0x07
 .equ ADCSRA = 0x06
 .equ ADCH = 0x05
 .equ ADCL = 0x04
 .equ TWDR = 0x03
 .equ TWAR = 0x02
 .equ TWSR = 0x01
 .equ TWBR = 0x00


; ***** BIT DEFINITIONS **************************************************

; ***** EEPROM ***********************
; EEDR - EEPROM Data Register
 .equ EEDR0 = 0    ; EEPROM Data Register bit 0
 .equ EEDR1 = 1    ; EEPROM Data Register bit 1
 .equ EEDR2 = 2    ; EEPROM Data Register bit 2
 .equ EEDR3 = 3    ; EEPROM Data Register bit 3
 .equ EEDR4 = 4    ; EEPROM Data Register bit 4
 .equ EEDR5 = 5    ; EEPROM Data Register bit 5
 .equ EEDR6 = 6    ; EEPROM Data Register bit 6
 .equ EEDR7 = 7    ; EEPROM Data Register bit 7

; EECR - EEPROM Control Register
 .equ EERE = 0    ; EEPROM Read Enable
 .equ EEWE = 1    ; EEPROM Write Enable
 .equ EEMWE = 2    ; EEPROM Master Write Enable
 .equ EERIE = 3    ; EEPROM Ready Interrupt Enable


; ***** WATCHDOG *********************
; WDTCR - Watchdog Timer Control Register
 .equ WDP0 = 0    ; Watch Dog Timer Prescaler bit 0
 .equ WDP1 = 1    ; Watch Dog Timer Prescaler bit 1
 .equ WDP2 = 2    ; Watch Dog Timer Prescaler bit 2
 .equ WDE = 3    ; Watch Dog Enable
 .equ WDTOE = 4    ; RW
 .equ WDDE = WDTOE    ; For compatibility


; ***** EXTERNAL_INTERRUPT ***********
; GICR - General Interrupt Control Register
 .equ GIMSK = GICR    ; For compatibility
 .equ IVCE = 0    ; Interrupt Vector Change Enable
 .equ IVSEL = 1    ; Interrupt Vector Select
 .equ INT2 = 5    ; External Interrupt Request 2 Enable
 .equ INT0 = 6    ; External Interrupt Request 0 Enable
 .equ INT1 = 7    ; External Interrupt Request 1 Enable

; GIFR - General Interrupt Flag Register
 .equ INTF2 = 5    ; External Interrupt Flag 2
 .equ INTF0 = 6    ; External Interrupt Flag 0
 .equ INTF1 = 7    ; External Interrupt Flag 1

; MCUCR - General Interrupt Control Register
 .equ ISC00 = 0    ; Interrupt Sense Control 0 Bit 0
 .equ ISC01 = 1    ; Interrupt Sense Control 0 Bit 1
 .equ ISC10 = 2    ; Interrupt Sense Control 1 Bit 0
 .equ ISC11 = 3    ; Interrupt Sense Control 1 Bit 1

; MCUCSR - MCU Control And Status Register
 .equ ISC2 = 6    ; Interrupt Sense Control 2


; ***** TIMER_COUNTER_0 **************
; TCCR0 - Timer/Counter Control Register
 .equ CS00 = 0    ; Clock Select 1
 .equ CS01 = 1    ; Clock Select 1
 .equ CS02 = 2    ; Clock Select 2
 .equ WGM01 = 3    ; Waveform Generation Mode 1
 .equ CTC0 = WGM01    ; For compatibility
 .equ COM00 = 4    ; Compare match Output Mode 0
 .equ COM01 = 5    ; Compare Match Output Mode 1
 .equ WGM00 = 6    ; Waveform Generation Mode
 .equ PWM0 = WGM00    ; For compatibility
 .equ FOC0 = 7    ; Force Output Compare

; TCNT0 - Timer/Counter Register
 .equ TCNT0_0 = 0    ;
 .equ TCNT0_1 = 1    ;
 .equ TCNT0_2 = 2    ;
 .equ TCNT0_3 = 3    ;
 .equ TCNT0_4 = 4    ;
 .equ TCNT0_5 = 5    ;
 .equ TCNT0_6 = 6    ;
 .equ TCNT0_7 = 7    ;

; OCR0 - Output Compare Register
 .equ OCR0_0 = 0    ;
 .equ OCR0_1 = 1    ;
 .equ OCR0_2 = 2    ;
 .equ OCR0_3 = 3    ;
 .equ OCR0_4 = 4    ;
 .equ OCR0_5 = 5    ;
 .equ OCR0_6 = 6    ;
 .equ OCR0_7 = 7    ;

; TIMSK - Timer/Counter Interrupt Mask Register
 .equ TOIE0 = 0    ; Timer/Counter0 Overflow Interrupt Enable
 .equ OCIE0 = 1    ; Timer/Counter0 Output Compare Match Interrupt regist

; TIFR - Timer/Counter Interrupt Flag register
 .equ TOV0 = 0    ; Timer/Counter0 Overflow Flag
 .equ OCF0 = 1    ; Output Compare Flag 0


; ***** TIMER_COUNTER_2 **************
; TIMSK - Timer/Counter Interrupt Mask register
 .equ TOIE2 = 6    ; Timer/Counter2 Overflow Interrupt Enable
 .equ OCIE2 = 7    ; Timer/Counter2 Output Compare Match Interrupt Enable

; TIFR - Timer/Counter Interrupt Flag Register
 .equ TOV2 = 6    ; Timer/Counter2 Overflow Flag
 .equ OCF2 = 7    ; Output Compare Flag 2

; TCCR2 - Timer/Counter2 Control Register
 .equ CS20 = 0    ; Clock Select bit 0
 .equ CS21 = 1    ; Clock Select bit 1
 .equ CS22 = 2    ; Clock Select bit 2
 .equ WGM21 = 3    ; Clear Timer/Counter2 on Compare Match
 .equ CTC2 = WGM21    ; For compatibility
 .equ COM20 = 4    ; Compare Output Mode bit 0
 .equ COM21 = 5    ; Compare Output Mode bit 1
 .equ WGM20 = 6    ; Pulse Width Modulator Enable
 .equ PWM2 = WGM20    ; For compatibility
 .equ FOC2 = 7    ; Force Output Compare

; TCNT2 - Timer/Counter2
 .equ TCNT2_0 = 0    ; Timer/Counter 2 bit 0
 .equ TCNT2_1 = 1    ; Timer/Counter 2 bit 1
 .equ TCNT2_2 = 2    ; Timer/Counter 2 bit 2
 .equ TCNT2_3 = 3    ; Timer/Counter 2 bit 3
 .equ TCNT2_4 = 4    ; Timer/Counter 2 bit 4
 .equ TCNT2_5 = 5    ; Timer/Counter 2 bit 5
 .equ TCNT2_6 = 6    ; Timer/Counter 2 bit 6
 .equ TCNT2_7 = 7    ; Timer/Counter 2 bit 7

; OCR2 - Timer/Counter2 Output Compare Register
 .equ OCR2_0 = 0    ; Timer/Counter2 Output Compare Register Bit 0
 .equ OCR2_1 = 1    ; Timer/Counter2 Output Compare Register Bit 1
 .equ OCR2_2 = 2    ; Timer/Counter2 Output Compare Register Bit 2
 .equ OCR2_3 = 3    ; Timer/Counter2 Output Compare Register Bit 3
 .equ OCR2_4 = 4    ; Timer/Counter2 Output Compare Register Bit 4
 .equ OCR2_5 = 5    ; Timer/Counter2 Output Compare Register Bit 5
 .equ OCR2_6 = 6    ; Timer/Counter2 Output Compare Register Bit 6
 .equ OCR2_7 = 7    ; Timer/Counter2 Output Compare Register Bit 7

; ASSR - Asynchronous Status Register
 .equ TCR2UB = 0    ; Timer/counter Control Register2 Update Busy
 .equ OCR2UB = 1    ; Output Compare Register2 Update Busy
 .equ TCN2UB = 2    ; Timer/Counter2 Update Busy
 .equ AS2 = 3    ; Asynchronous Timer/counter2


; ***** TIMER_COUNTER_1 **************
; TIMSK - Timer/Counter Interrupt Mask Register
 .equ TOIE1 = 2    ; Timer/Counter1 Overflow Interrupt Enable
 .equ OCIE1B = 3    ; Timer/Counter1 Output CompareB Match Interrupt Enab
 .equ OCIE1A = 4    ; Timer/Counter1 Output CompareA Match Interrupt Enab
 .equ TICIE1 = 5    ; Timer/Counter1 Input Capture Interrupt Enable

; TIFR - Timer/Counter Interrupt Flag register
 .equ TOV1 = 2    ; Timer/Counter1 Overflow Flag
 .equ OCF1B = 3    ; Output Compare Flag 1B
 .equ OCF1A = 4    ; Output Compare Flag 1A
 .equ ICF1 = 5    ; Input Capture Flag 1

; TCCR1A - Timer/Counter1 Control Register A
 .equ WGM10 = 0    ; Waveform Generation Mode
 .equ PWM10 = WGM10    ; For compatibility
 .equ WGM11 = 1    ; Waveform Generation Mode
 .equ PWM11 = WGM11    ; For compatibility
 .equ FOC1B = 2    ; Force Output Compare 1B
 .equ FOC1A = 3    ; Force Output Compare 1A
 .equ COM1B0 = 4    ; Compare Output Mode 1B, bit 0
 .equ COM1B1 = 5    ; Compare Output Mode 1B, bit 1
 .equ COM1A0 = 6    ; Compare Ouput Mode 1A, bit 0
 .equ COM1A1 = 7    ; Compare Output Mode 1A, bit 1

; TCCR1B - Timer/Counter1 Control Register B
 .equ CS10 = 0    ; Prescaler source of Timer/Counter 1
 .equ CS11 = 1    ; Prescaler source of Timer/Counter 1
 .equ CS12 = 2    ; Prescaler source of Timer/Counter 1
 .equ WGM12 = 3    ; Waveform Generation Mode
 .equ CTC10 = WGM12    ; For compatibility
 .equ CTC1 = WGM12    ; For compatibility
 .equ WGM13 = 4    ; Waveform Generation Mode
 .equ CTC11 = WGM13    ; For compatibility
 .equ ICES1 = 6    ; Input Capture 1 Edge Select
 .equ ICNC1 = 7    ; Input Capture 1 Noise Canceler


; ***** SPI **************************
; SPDR - SPI Data Register
 .equ SPDR0 = 0    ; SPI Data Register bit 0
 .equ SPDR1 = 1    ; SPI Data Register bit 1
 .equ SPDR2 = 2    ; SPI Data Register bit 2
 .equ SPDR3 = 3    ; SPI Data Register bit 3
 .equ SPDR4 = 4    ; SPI Data Register bit 4
 .equ SPDR5 = 5    ; SPI Data Register bit 5
 .equ SPDR6 = 6    ; SPI Data Register bit 6
 .equ SPDR7 = 7    ; SPI Data Register bit 7

; SPSR - SPI Status Register
 .equ SPI2X = 0    ; Double SPI Speed Bit
 .equ WCOL = 6    ; Write Collision Flag
 .equ SPIF = 7    ; SPI Interrupt Flag

; SPCR - SPI Control Register
 .equ SPR0 = 0    ; SPI Clock Rate Select 0
 .equ SPR1 = 1    ; SPI Clock Rate Select 1
 .equ CPHA = 2    ; Clock Phase
 .equ CPOL = 3    ; Clock polarity
 .equ MSTR = 4    ; Master/Slave Select
 .equ DORD = 5    ; Data Order
 .equ SPE = 6    ; SPI Enable
 .equ SPIE = 7    ; SPI Interrupt Enable


; ***** USART ************************
; UDR - USART I/O Data Register
 .equ UDR0 = 0    ; USART I/O Data Register bit 0
 .equ UDR1 = 1    ; USART I/O Data Register bit 1
 .equ UDR2 = 2    ; USART I/O Data Register bit 2
 .equ UDR3 = 3    ; USART I/O Data Register bit 3
 .equ UDR4 = 4    ; USART I/O Data Register bit 4
 .equ UDR5 = 5    ; USART I/O Data Register bit 5
 .equ UDR6 = 6    ; USART I/O Data Register bit 6
 .equ UDR7 = 7    ; USART I/O Data Register bit 7

; UCSRA - USART Control and Status Register A
 .equ USR = UCSRA    ; For compatibility
 .equ MPCM = 0    ; Multi-processor Communication Mode
 .equ U2X = 1    ; Double the USART transmission speed
 .equ UPE = 2    ; Parity Error
 .equ PE = UPE    ; For compatibility
 .equ DOR = 3    ; Data overRun
 .equ FE = 4    ; Framing Error
 .equ UDRE = 5    ; USART Data Register Empty
 .equ TXC = 6    ; USART Transmitt Complete
 .equ RXC = 7    ; USART Receive Complete

; UCSRB - USART Control and Status Register B
 .equ UCR = UCSRB    ; For compatibility
 .equ TXB8 = 0    ; Transmit Data Bit 8
 .equ RXB8 = 1    ; Receive Data Bit 8
 .equ UCSZ2 = 2    ; Character Size
 .equ CHR9 = UCSZ2    ; For compatibility
 .equ TXEN = 3    ; Transmitter Enable
 .equ RXEN = 4    ; Receiver Enable
 .equ UDRIE = 5    ; USART Data register Empty Interrupt Enable
 .equ TXCIE = 6    ; TX Complete Interrupt Enable
 .equ RXCIE = 7    ; RX Complete Interrupt Enable

; UCSRC - USART Control and Status Register C
 .equ UCPOL = 0    ; Clock Polarity
 .equ UCSZ0 = 1    ; Character Size
 .equ UCSZ1 = 2    ; Character Size
 .equ USBS = 3    ; Stop Bit Select
 .equ UPM0 = 4    ; Parity Mode Bit 0
 .equ UPM1 = 5    ; Parity Mode Bit 1
 .equ UMSEL = 6    ; USART Mode Select
 .equ URSEL = 7    ; Register Select

 .equ UBRRHI = UBRRH    ; For compatibility

; ***** ANALOG_COMPARATOR ************
; SFIOR - Special Function IO Register
 .equ ACME = 3    ; Analog Comparator Multiplexer Enable

; ACSR - Analog Comparator Control And Status Register
 .equ ACIS0 = 0    ; Analog Comparator Interrupt Mode Select bit 0
 .equ ACIS1 = 1    ; Analog Comparator Interrupt Mode Select bit 1
 .equ ACIC = 2    ; Analog Comparator Input Capture Enable
 .equ ACIE = 3    ; Analog Comparator Interrupt Enable
 .equ ACI = 4    ; Analog Comparator Interrupt Flag
 .equ ACO = 5    ; Analog Compare Output
 .equ ACBG = 6    ; Analog Comparator Bandgap Select
 .equ ACD = 7    ; Analog Comparator Disable


; ***** AD_CONVERTER *****************
; ADMUX - The ADC multiplexer Selection Register
 .equ MUX0 = 0    ; Analog Channel and Gain Selection Bits
 .equ MUX1 = 1    ; Analog Channel and Gain Selection Bits
 .equ MUX2 = 2    ; Analog Channel and Gain Selection Bits
 .equ MUX3 = 3    ; Analog Channel and Gain Selection Bits
 .equ MUX4 = 4    ; Analog Channel and Gain Selection Bits
 .equ ADLAR = 5    ; Left Adjust Result
 .equ REFS0 = 6    ; Reference Selection Bit 0
 .equ REFS1 = 7    ; Reference Selection Bit 1

; ADCSRA - The ADC Control and Status register
 .equ ADCSR = ADCSRA    ; For compatibility
 .equ ADPS0 = 0    ; ADC  Prescaler Select Bits
 .equ ADPS1 = 1    ; ADC  Prescaler Select Bits
 .equ ADPS2 = 2    ; ADC  Prescaler Select Bits
 .equ ADIE = 3    ; ADC Interrupt Enable
 .equ ADIF = 4    ; ADC Interrupt Flag
 .equ ADATE = 5    ; When this bit is written to one,the Timer/Counter2 p
 .equ ADFR = ADATE    ; For compatibility
 .equ ADSC = 6    ; ADC Start Conversion
 .equ ADEN = 7    ; ADC Enable

; ADCH - ADC Data Register High Byte
 .equ ADCH0 = 0    ; ADC Data Register High Byte Bit 0
 .equ ADCH1 = 1    ; ADC Data Register High Byte Bit 1
 .equ ADCH2 = 2    ; ADC Data Register High Byte Bit 2
 .equ ADCH3 = 3    ; ADC Data Register High Byte Bit 3
 .equ ADCH4 = 4    ; ADC Data Register High Byte Bit 4
 .equ ADCH5 = 5    ; ADC Data Register High Byte Bit 5
 .equ ADCH6 = 6    ; ADC Data Register High Byte Bit 6
 .equ ADCH7 = 7    ; ADC Data Register High Byte Bit 7

; ADCL - ADC Data Register Low Byte
 .equ ADCL0 = 0    ; ADC Data Register Low Byte Bit 0
 .equ ADCL1 = 1    ; ADC Data Register Low Byte Bit 1
 .equ ADCL2 = 2    ; ADC Data Register Low Byte Bit 2
 .equ ADCL3 = 3    ; ADC Data Register Low Byte Bit 3
 .equ ADCL4 = 4    ; ADC Data Register Low Byte Bit 4
 .equ ADCL5 = 5    ; ADC Data Register Low Byte Bit 5
 .equ ADCL6 = 6    ; ADC Data Register Low Byte Bit 6
 .equ ADCL7 = 7    ; ADC Data Register Low Byte Bit 7

; SFIOR - Special Function IO Register
 .equ ADTS0 = 5    ; ADC Auto Trigger Source 0
 .equ ADTS1 = 6    ; ADC Auto Trigger Source 1
 .equ ADTS2 = 7    ; ADC Auto Trigger Source 2


; ***** PORTA ************************
; PORTA - Port A Data Register
 .equ PORTA0 = 0    ; Port A Data Register bit 0
 .equ PA0 = 0    ; For compatibility
 .equ PORTA1 = 1    ; Port A Data Register bit 1
 .equ PA1 = 1    ; For compatibility
 .equ PORTA2 = 2    ; Port A Data Register bit 2
 .equ PA2 = 2    ; For compatibility
 .equ PORTA3 = 3    ; Port A Data Register bit 3
 .equ PA3 = 3    ; For compatibility
 .equ PORTA4 = 4    ; Port A Data Register bit 4
 .equ PA4 = 4    ; For compatibility
 .equ PORTA5 = 5    ; Port A Data Register bit 5
 .equ PA5 = 5    ; For compatibility
 .equ PORTA6 = 6    ; Port A Data Register bit 6
 .equ PA6 = 6    ; For compatibility
 .equ PORTA7 = 7    ; Port A Data Register bit 7
 .equ PA7 = 7    ; For compatibility

; DDRA - Port A Data Direction Register
 .equ DDA0 = 0    ; Data Direction Register, Port A, bit 0
 .equ DDA1 = 1    ; Data Direction Register, Port A, bit 1
 .equ DDA2 = 2    ; Data Direction Register, Port A, bit 2
 .equ DDA3 = 3    ; Data Direction Register, Port A, bit 3
 .equ DDA4 = 4    ; Data Direction Register, Port A, bit 4
 .equ DDA5 = 5    ; Data Direction Register, Port A, bit 5
 .equ DDA6 = 6    ; Data Direction Register, Port A, bit 6
 .equ DDA7 = 7    ; Data Direction Register, Port A, bit 7

; PINA - Port A Input Pins
 .equ PINA0 = 0    ; Input Pins, Port A bit 0
 .equ PINA1 = 1    ; Input Pins, Port A bit 1
 .equ PINA2 = 2    ; Input Pins, Port A bit 2
 .equ PINA3 = 3    ; Input Pins, Port A bit 3
 .equ PINA4 = 4    ; Input Pins, Port A bit 4
 .equ PINA5 = 5    ; Input Pins, Port A bit 5
 .equ PINA6 = 6    ; Input Pins, Port A bit 6
 .equ PINA7 = 7    ; Input Pins, Port A bit 7


; ***** PORTB ************************
; PORTB - Port B Data Register
 .equ PORTB0 = 0    ; Port B Data Register bit 0
 .equ PB0 = 0    ; For compatibility
 .equ PORTB1 = 1    ; Port B Data Register bit 1
 .equ PB1 = 1    ; For compatibility
 .equ PORTB2 = 2    ; Port B Data Register bit 2
 .equ PB2 = 2    ; For compatibility
 .equ PORTB3 = 3    ; Port B Data Register bit 3
 .equ PB3 = 3    ; For compatibility
 .equ PORTB4 = 4    ; Port B Data Register bit 4
 .equ PB4 = 4    ; For compatibility
 .equ PORTB5 = 5    ; Port B Data Register bit 5
 .equ PB5 = 5    ; For compatibility
 .equ PORTB6 = 6    ; Port B Data Register bit 6
 .equ PB6 = 6    ; For compatibility
 .equ PORTB7 = 7    ; Port B Data Register bit 7
 .equ PB7 = 7    ; For compatibility

; DDRB - Port B Data Direction Register
 .equ DDB0 = 0    ; Port B Data Direction Register bit 0
 .equ DDB1 = 1    ; Port B Data Direction Register bit 1
 .equ DDB2 = 2    ; Port B Data Direction Register bit 2
 .equ DDB3 = 3    ; Port B Data Direction Register bit 3
 .equ DDB4 = 4    ; Port B Data Direction Register bit 4
 .equ DDB5 = 5    ; Port B Data Direction Register bit 5
 .equ DDB6 = 6    ; Port B Data Direction Register bit 6
 .equ DDB7 = 7    ; Port B Data Direction Register bit 7

; PINB - Port B Input Pins
 .equ PINB0 = 0    ; Port B Input Pins bit 0
 .equ PINB1 = 1    ; Port B Input Pins bit 1
 .equ PINB2 = 2    ; Port B Input Pins bit 2
 .equ PINB3 = 3    ; Port B Input Pins bit 3
 .equ PINB4 = 4    ; Port B Input Pins bit 4
 .equ PINB5 = 5    ; Port B Input Pins bit 5
 .equ PINB6 = 6    ; Port B Input Pins bit 6
 .equ PINB7 = 7    ; Port B Input Pins bit 7


; ***** PORTC ************************
; PORTC - Port C Data Register
 .equ PORTC0 = 0    ; Port C Data Register bit 0
 .equ PC0 = 0    ; For compatibility
 .equ PORTC1 = 1    ; Port C Data Register bit 1
 .equ PC1 = 1    ; For compatibility
 .equ PORTC2 = 2    ; Port C Data Register bit 2
 .equ PC2 = 2    ; For compatibility
 .equ PORTC3 = 3    ; Port C Data Register bit 3
 .equ PC3 = 3    ; For compatibility
 .equ PORTC4 = 4    ; Port C Data Register bit 4
 .equ PC4 = 4    ; For compatibility
 .equ PORTC5 = 5    ; Port C Data Register bit 5
 .equ PC5 = 5    ; For compatibility
 .equ PORTC6 = 6    ; Port C Data Register bit 6
 .equ PC6 = 6    ; For compatibility
 .equ PORTC7 = 7    ; Port C Data Register bit 7
 .equ PC7 = 7    ; For compatibility

; DDRC - Port C Data Direction Register
 .equ DDC0 = 0    ; Port C Data Direction Register bit 0
 .equ DDC1 = 1    ; Port C Data Direction Register bit 1
 .equ DDC2 = 2    ; Port C Data Direction Register bit 2
 .equ DDC3 = 3    ; Port C Data Direction Register bit 3
 .equ DDC4 = 4    ; Port C Data Direction Register bit 4
 .equ DDC5 = 5    ; Port C Data Direction Register bit 5
 .equ DDC6 = 6    ; Port C Data Direction Register bit 6
 .equ DDC7 = 7    ; Port C Data Direction Register bit 7

; PINC - Port C Input Pins
 .equ PINC0 = 0    ; Port C Input Pins bit 0
 .equ PINC1 = 1    ; Port C Input Pins bit 1
 .equ PINC2 = 2    ; Port C Input Pins bit 2
 .equ PINC3 = 3    ; Port C Input Pins bit 3
 .equ PINC4 = 4    ; Port C Input Pins bit 4
 .equ PINC5 = 5    ; Port C Input Pins bit 5
 .equ PINC6 = 6    ; Port C Input Pins bit 6
 .equ PINC7 = 7    ; Port C Input Pins bit 7


; ***** PORTD ************************
; PORTD - Port D Data Register
 .equ PORTD0 = 0    ; Port D Data Register bit 0
 .equ PD0 = 0    ; For compatibility
 .equ PORTD1 = 1    ; Port D Data Register bit 1
 .equ PD1 = 1    ; For compatibility
 .equ PORTD2 = 2    ; Port D Data Register bit 2
 .equ PD2 = 2    ; For compatibility
 .equ PORTD3 = 3    ; Port D Data Register bit 3
 .equ PD3 = 3    ; For compatibility
 .equ PORTD4 = 4    ; Port D Data Register bit 4
 .equ PD4 = 4    ; For compatibility
 .equ PORTD5 = 5    ; Port D Data Register bit 5
 .equ PD5 = 5    ; For compatibility
 .equ PORTD6 = 6    ; Port D Data Register bit 6
 .equ PD6 = 6    ; For compatibility
 .equ PORTD7 = 7    ; Port D Data Register bit 7
 .equ PD7 = 7    ; For compatibility

; DDRD - Port D Data Direction Register
 .equ DDD0 = 0    ; Port D Data Direction Register bit 0
 .equ DDD1 = 1    ; Port D Data Direction Register bit 1
 .equ DDD2 = 2    ; Port D Data Direction Register bit 2
 .equ DDD3 = 3    ; Port D Data Direction Register bit 3
 .equ DDD4 = 4    ; Port D Data Direction Register bit 4
 .equ DDD5 = 5    ; Port D Data Direction Register bit 5
 .equ DDD6 = 6    ; Port D Data Direction Register bit 6
 .equ DDD7 = 7    ; Port D Data Direction Register bit 7

; PIND - Port D Input Pins
 .equ PIND0 = 0    ; Port D Input Pins bit 0
 .equ PIND1 = 1    ; Port D Input Pins bit 1
 .equ PIND2 = 2    ; Port D Input Pins bit 2
 .equ PIND3 = 3    ; Port D Input Pins bit 3
 .equ PIND4 = 4    ; Port D Input Pins bit 4
 .equ PIND5 = 5    ; Port D Input Pins bit 5
 .equ PIND6 = 6    ; Port D Input Pins bit 6
 .equ PIND7 = 7    ; Port D Input Pins bit 7


; ***** CPU **************************
; SREG - Status Register
 .equ SREG_C = 0    ; Carry Flag
 .equ SREG_Z = 1    ; Zero Flag
 .equ SREG_N = 2    ; Negative Flag
 .equ SREG_V = 3    ; Two's Complement Overflow Flag
 .equ SREG_S = 4    ; Sign Bit
 .equ SREG_H = 5    ; Half Carry Flag
 .equ SREG_T = 6    ; Bit Copy Storage
 .equ SREG_I = 7    ; Global Interrupt Enable

; MCUCR - MCU Control Register
;.equ    ISC00    = 0    ; Interrupt Sense Control 0 Bit 0
;.equ    ISC01    = 1    ; Interrupt Sense Control 0 Bit 1
;.equ    ISC10    = 2    ; Interrupt Sense Control 1 Bit 0
;.equ    ISC11    = 3    ; Interrupt Sense Control 1 Bit 1
 .equ SM0 = 4    ; Sleep Mode Select
 .equ SM1 = 5    ; Sleep Mode Select
 .equ SM2 = 6    ; Sleep Mode Select
 .equ SE = 7    ; Sleep Enable

; MCUCSR - MCU Control And Status Register
 .equ MCUSR = MCUCSR    ; For compatibility
 .equ PORF = 0    ; Power-on reset flag
 .equ EXTRF = 1    ; External Reset Flag
 .equ BORF = 2    ; Brown-out Reset Flag
 .equ WDRF = 3    ; Watchdog Reset Flag
 .equ JTRF = 4    ; JTAG Reset Flag
 .equ JTD = 7    ; JTAG Interface Disable

; OSCCAL - Oscillator Calibration Value
 .equ CAL0 = 0    ; Oscillator Calibration Value Bit0
 .equ CAL1 = 1    ; Oscillator Calibration Value Bit1
 .equ CAL2 = 2    ; Oscillator Calibration Value Bit2
 .equ CAL3 = 3    ; Oscillator Calibration Value Bit3
 .equ CAL4 = 4    ; Oscillator Calibration Value Bit4
 .equ CAL5 = 5    ; Oscillator Calibration Value Bit5
 .equ CAL6 = 6    ; Oscillator Calibration Value Bit6
 .equ CAL7 = 7    ; Oscillator Calibration Value Bit7

; SFIOR - Special Function IO Register
 .equ PSR10 = 0    ; Prescaler Reset Timer/Counter1&0
 .equ PSR2 = 1    ; Prescaler Reset Timer/Counter2
 .equ PUD = 2    ; Pull-up Disable


; ***** BOOT_LOAD ********************
; SPMCR - Store Program Memory Control Register
 .equ SPMEN = 0    ; Store Program Memory Enable
 .equ PGERS = 1    ; Page Erase
 .equ PGWRT = 2    ; Page Write
 .equ BLBSET = 3    ; Boot Lock Bit Set
 .equ RWWSRE = 4    ; Read While Write secion read enable
 .equ ASRE = RWWSRE    ; For compatibility
 .equ RWWSB = 6    ; Read While Write Section Busy
 .equ ASB = RWWSB    ; For compatibility
 .equ SPMIE = 7    ; SPM Interrupt Enable


; ***** TWI **************************
; TWBR - TWI Bit Rate register
 .equ TWBR0 = 0    ;
 .equ TWBR1 = 1    ;
 .equ TWBR2 = 2    ;
 .equ TWBR3 = 3    ;
 .equ TWBR4 = 4    ;
 .equ TWBR5 = 5    ;
 .equ TWBR6 = 6    ;
 .equ TWBR7 = 7    ;

; TWCR - TWI Control Register
 .equ TWIE = 0    ; TWI Interrupt Enable
 .equ TWEN = 2    ; TWI Enable Bit
 .equ TWWC = 3    ; TWI Write Collition Flag
 .equ TWSTO = 4    ; TWI Stop Condition Bit
 .equ TWSTA = 5    ; TWI Start Condition Bit
 .equ TWEA = 6    ; TWI Enable Acknowledge Bit
 .equ TWINT = 7    ; TWI Interrupt Flag

; TWSR - TWI Status Register
 .equ TWPS0 = 0    ; TWI Prescaler bits
 .equ TWPS1 = 1    ; TWI Prescaler bits
 .equ TWS3 = 3    ; TWI Status
 .equ TWS4 = 4    ; TWI Status
 .equ TWS5 = 5    ; TWI Status
 .equ TWS6 = 6    ; TWI Status
 .equ TWS7 = 7    ; TWI Status

; TWDR - TWI Data register
 .equ TWD0 = 0    ; TWI Data Register Bit 0
 .equ TWD1 = 1    ; TWI Data Register Bit 1
 .equ TWD2 = 2    ; TWI Data Register Bit 2
 .equ TWD3 = 3    ; TWI Data Register Bit 3
 .equ TWD4 = 4    ; TWI Data Register Bit 4
 .equ TWD5 = 5    ; TWI Data Register Bit 5
 .equ TWD6 = 6    ; TWI Data Register Bit 6
 .equ TWD7 = 7    ; TWI Data Register Bit 7

; TWAR - TWI (Slave) Address register
 .equ TWGCE = 0    ; TWI General Call Recognition Enable Bit
 .equ TWA0 = 1    ; TWI (Slave) Address register Bit 0
 .equ TWA1 = 2    ; TWI (Slave) Address register Bit 1
 .equ TWA2 = 3    ; TWI (Slave) Address register Bit 2
 .equ TWA3 = 4    ; TWI (Slave) Address register Bit 3
 .equ TWA4 = 5    ; TWI (Slave) Address register Bit 4
 .equ TWA5 = 6    ; TWI (Slave) Address register Bit 5
 .equ TWA6 = 7    ; TWI (Slave) Address register Bit 6



; ***** LOCKSBITS ********************************************************
 .equ LB1 = 0    ; Lock bit
 .equ LB2 = 1    ; Lock bit
 .equ BLB01 = 2    ; Boot Lock bit
 .equ BLB02 = 3    ; Boot Lock bit
 .equ BLB11 = 4    ; Boot lock bit
 .equ BLB12 = 5    ; Boot lock bit


; ***** FUSES ************************************************************
; LOW fuse bits
 .equ CKSEL0 = 0    ; Select Clock Source
 .equ CKSEL1 = 1    ; Select Clock Source
 .equ CKSEL2 = 2    ; Select Clock Source
 .equ CKSEL3 = 3    ; Select Clock Source
 .equ BODEN = 6    ; Brown out detector enable
 .equ BODLEVEL = 7    ; Brown out detector trigger level

; HIGH fuse bits
 .equ BOOTRST = 0    ; Select Reset Vector
 .equ BOOTSZ0 = 1    ; Select Boot Size
 .equ BOOTSZ1 = 2    ; Select Boot Size
 .equ EESAVE = 3    ; EEPROM memory is preserved through chip erase
 .equ SPIEN = 5    ; Enable Serial programming and Data Downloading
 .equ JTAGEN = 6    ; Enable JTAG
 .equ OCDEN = 7    ; Enable OCD



; ***** CPU REGISTER DEFINITIONS *****************************************
;.def    XH    = r27
;.def    XL    = r26
;.def    YH    = r29
;.def    YL    = r28
;.def    ZH    = r31
;.def    ZL    = r30



; ***** DATA MEMORY DECLARATIONS *****************************************
 .equ FLASHEND = 0x3fff    ; Note: Word address
 .equ IOEND = 0x003f
 .equ SRAM_START = 0x0060
 .equ SRAM_SIZE = 2048
 .equ RAMEND = 0x085f
 .equ XRAMEND = 0x0000
 .equ E2END = 0x03ff
 .equ EEPROMEND = 0x03ff
 .equ EEADRBITS = 10
;#pragma AVRPART MEMORY PROG_FLASH 32768
;#pragma AVRPART MEMORY EEPROM 1024
;#pragma AVRPART MEMORY INT_SRAM SIZE 2048
;#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60



; ***** BOOTLOADER DECLARATIONS ******************************************
 .equ NRWW_START_ADDR = 0x3800
 .equ NRWW_STOP_ADDR = 0x3fff
 .equ RWW_START_ADDR = 0x0
 .equ RWW_STOP_ADDR = 0x37ff
 .equ PAGESIZE = 64
 .equ FIRSTBOOTSTART = 0x3f00
 .equ SECONDBOOTSTART = 0x3e00
 .equ THIRDBOOTSTART = 0x3c00
 .equ FOURTHBOOTSTART = 0x3800
 .equ SMALLBOOTSTART = FIRSTBOOTSTART
 .equ LARGEBOOTSTART = FOURTHBOOTSTART



; ***** INTERRUPT VECTORS ************************************************
 .equ INT0addr = 0x0002    ; External Interrupt Request 0
 .equ INT1addr = 0x0004    ; External Interrupt Request 1
 .equ INT2addr = 0x0006    ; External Interrupt Request 2
 .equ OC2addr = 0x0008    ; Timer/Counter2 Compare Match
 .equ OVF2addr = 0x000a    ; Timer/Counter2 Overflow
 .equ ICP1addr = 0x000c    ; Timer/Counter1 Capture Event
 .equ OC1Aaddr = 0x000e    ; Timer/Counter1 Compare Match A
 .equ OC1Baddr = 0x0010    ; Timer/Counter1 Compare Match B
 .equ OVF1addr = 0x0012    ; Timer/Counter1 Overflow
 .equ OC0addr = 0x0014    ; Timer/Counter0 Compare Match
 .equ OVF0addr = 0x0016    ; Timer/Counter0 Overflow
 .equ SPIaddr = 0x0018    ; Serial Transfer Complete
 .equ URXCaddr = 0x001a    ; USART, Rx Complete
 .equ UDREaddr = 0x001c    ; USART Data Register Empty
 .equ UTXCaddr = 0x001e    ; USART, Tx Complete
 .equ ADCCaddr = 0x0020    ; ADC Conversion Complete
 .equ ERDYaddr = 0x0022    ; EEPROM Ready
 .equ ACIaddr = 0x0024    ; Analog Comparator
 .equ TWIaddr = 0x0026    ; 2-wire Serial Interface
 .equ SPMRaddr = 0x0028    ; Store Program Memory Ready

 .equ INT_VECTORS_SIZE = 42    ; size in words

;#endif  /* _M32DEF_INC_ */

; ***** END OF FILE ******************************************************

 SetAsmDefinitions:

    ret
 .endif
;-------------------------------------------------
 .ifdef TagSetAsmDefinitions128

;***** THIS IS A MACHINE GENERATED FILE - DO NOT EDIT ********************
;***** Created: 2009-11-03 14:40 ******* Source: ATmega128.xml ***********
;*************************************************************************
;* A P P L I C A T I O N   N O T E   F O R   T H E   A V R   F A M I L Y
;*
;* Number            : AVR000
;* File Name         : "m128def.inc"
;* Title             : Register/Bit Definitions for the ATmega128
;* Date              : 2009-11-03
;* Version           : 2.35
;* Support E-mail    : avr@atmel.com
;* Target MCU        : ATmega128
;*
;* DESCRIPTION
;* When including this file in the assembly program file, all I/O register
;* names and I/O register bit names appearing in the data book can be used.
;* In addition, the six registers forming the three data pointers X, Y and
;* Z have been assigned names XL - ZH. Highest RAM address for Internal
;* SRAM is also defined
;*
;* The Register names are represented by their hexadecimal address.
;*
;* The Register Bit names are represented by their bit number (0-7).
;*
;* Please observe the difference in using the bit names with instructions
;* such as "sbr"/"cbr" (set/clear bit in register) and "sbrs"/"sbrc"
;* (skip if bit in register set/cleared). The following example illustrates
;* this:
;*
;* in    r16,PORTB             ;read PORTB latch
;* sbr   r16,(1<<PB6)+(1<<PB5) ;set PB6 and PB5 (use masks, not bit#)
;* out   PORTB,r16             ;output to PORTB
;*
;* in    r16,TIFR              ;read the Timer Interrupt Flag Register
;* sbrc  r16,TOV0              ;test the overflow flag (use bit#)
;* rjmp  TOV0_is_set           ;jump if set
;* ...                         ;otherwise do something else
;*************************************************************************

;#ifndef _M128DEF_INC_
;#define _M128DEF_INC_


;#pragma partinc 0

; ***** SPECIFY DEVICE ***************************************************
;.device ATmega128
;#pragma AVRPART ADMIN PART_NAME ATmega128
 .equ SIGNATURE_000 = 0x1e
 .equ SIGNATURE_001 = 0x97
 .equ SIGNATURE_002 = 0x02

;#pragma AVRPART CORE CORE_VERSION V2E


; ***** I/O REGISTER DEFINITIONS *****************************************
; NOTE:
; Definitions marked "MEMORY MAPPED"are extended I/O ports
; and cannot be used with IN/OUT instructions
 .equ UCSR1C = 0x9d    ; MEMORY MAPPED
 .equ UDR1 = 0x9c    ; MEMORY MAPPED
 .equ UCSR1A = 0x9b    ; MEMORY MAPPED
 .equ UCSR1B = 0x9a    ; MEMORY MAPPED
 .equ UBRR1H = 0x98    ; MEMORY MAPPED
 .equ UBRR1L = 0x99    ; MEMORY MAPPED
 .equ UCSR0C = 0x95    ; MEMORY MAPPED
 .equ UBRR0H = 0x90    ; MEMORY MAPPED
 .equ TCCR3C = 0x8c    ; MEMORY MAPPED
 .equ TCCR3A = 0x8b    ; MEMORY MAPPED
 .equ TCCR3B = 0x8a    ; MEMORY MAPPED
 .equ TCNT3L = 0x88    ; MEMORY MAPPED
 .equ TCNT3H = 0x89    ; MEMORY MAPPED
 .equ OCR3AL = 0x86    ; MEMORY MAPPED
 .equ OCR3AH = 0x87    ; MEMORY MAPPED
 .equ OCR3BL = 0x84    ; MEMORY MAPPED
 .equ OCR3BH = 0x85    ; MEMORY MAPPED
 .equ OCR3CL = 0x82    ; MEMORY MAPPED
 .equ OCR3CH = 0x83    ; MEMORY MAPPED
 .equ ICR3L = 0x80    ; MEMORY MAPPED
 .equ ICR3H = 0x81    ; MEMORY MAPPED
 .equ ETIMSK = 0x7d    ; MEMORY MAPPED
 .equ ETIFR = 0x7c    ; MEMORY MAPPED
 .equ TCCR1C = 0x7a    ; MEMORY MAPPED
 .equ OCR1CL = 0x78    ; MEMORY MAPPED
 .equ OCR1CH = 0x79    ; MEMORY MAPPED
 .equ TWCR = 0x74    ; MEMORY MAPPED
 .equ TWDR = 0x73    ; MEMORY MAPPED
 .equ TWAR = 0x72    ; MEMORY MAPPED
 .equ TWSR = 0x71    ; MEMORY MAPPED
 .equ TWBR = 0x70    ; MEMORY MAPPED
 .equ OSCCAL = 0x6f    ; MEMORY MAPPED
 .equ XMCRA = 0x6d    ; MEMORY MAPPED
 .equ XMCRB = 0x6c    ; MEMORY MAPPED
 .equ EICRA = 0x6a    ; MEMORY MAPPED
 .equ SPMCSR = 0x68    ; MEMORY MAPPED
 .equ PORTG = 0x65    ; MEMORY MAPPED
 .equ DDRG = 0x64    ; MEMORY MAPPED
 .equ PING = 0x63    ; MEMORY MAPPED
 .equ PORTF = 0x62    ; MEMORY MAPPED
 .equ DDRF = 0x61    ; MEMORY MAPPED
 .equ SREG = 0x3f
 .equ SPL = 0x3d
 .equ SPH = 0x3e
 .equ XDIV = 0x3c
 .equ RAMPZ = 0x3b
 .equ EICRB = 0x3a
 .equ EIMSK = 0x39
 .equ EIFR = 0x38
 .equ TIMSK = 0x37
 .equ TIFR = 0x36
 .equ MCUCR = 0x35
 .equ MCUCSR = 0x34
 .equ TCCR0 = 0x33
 .equ TCNT0 = 0x32
 .equ OCR0 = 0x31
 .equ ASSR = 0x30
 .equ TCCR1A = 0x2f
 .equ TCCR1B = 0x2e
 .equ TCNT1L = 0x2c
 .equ TCNT1H = 0x2d
 .equ OCR1AL = 0x2a
 .equ OCR1AH = 0x2b
 .equ OCR1BL = 0x28
 .equ OCR1BH = 0x29
 .equ ICR1L = 0x26
 .equ ICR1H = 0x27
 .equ TCCR2 = 0x25
 .equ TCNT2 = 0x24
 .equ OCR2 = 0x23
 .equ OCDR = 0x22
 .equ WDTCR = 0x21
 .equ SFIOR = 0x20
 .equ EEARL = 0x1e
 .equ EEARH = 0x1f
 .equ EEDR = 0x1d
 .equ EECR = 0x1c
 .equ PORTA = 0x1b
 .equ DDRA = 0x1a
 .equ PINA = 0x19
 .equ PORTB = 0x18
 .equ DDRB = 0x17
 .equ PINB = 0x16
 .equ PORTC = 0x15
 .equ DDRC = 0x14
 .equ PINC = 0x13
 .equ PORTD = 0x12
 .equ DDRD = 0x11
 .equ PIND = 0x10
 .equ SPDR = 0x0f
 .equ SPSR = 0x0e
 .equ SPCR = 0x0d
 .equ UDR0 = 0x0c
 .equ UCSR0A = 0x0b
 .equ UCSR0B = 0x0a
 .equ UBRR0L = 0x09
 .equ ACSR = 0x08
 .equ ADMUX = 0x07
 .equ ADCSRA = 0x06
 .equ ADCH = 0x05
 .equ ADCL = 0x04
 .equ PORTE = 0x03
 .equ DDRE = 0x02
 .equ PINE = 0x01
 .equ PINF = 0x00


; ***** BIT DEFINITIONS **************************************************

; ***** ANALOG_COMPARATOR ************
; SFIOR - Special Function IO Register
 .equ ACME = 3    ; Analog Comparator Multiplexer Enable

; ACSR - Analog Comparator Control And Status Register
 .equ ACIS0 = 0    ; Analog Comparator Interrupt Mode Select bit 0
 .equ ACIS1 = 1    ; Analog Comparator Interrupt Mode Select bit 1
 .equ ACIC = 2    ; Analog Comparator Input Capture Enable
 .equ ACIE = 3    ; Analog Comparator Interrupt Enable
 .equ ACI = 4    ; Analog Comparator Interrupt Flag
 .equ ACO = 5    ; Analog Compare Output
 .equ ACBG = 6    ; Analog Comparator Bandgap Select
 .equ ACD = 7    ; Analog Comparator Disable


; ***** SPI **************************
; SPDR - SPI Data Register
 .equ SPDR0 = 0    ; SPI Data Register bit 0
 .equ SPDR1 = 1    ; SPI Data Register bit 1
 .equ SPDR2 = 2    ; SPI Data Register bit 2
 .equ SPDR3 = 3    ; SPI Data Register bit 3
 .equ SPDR4 = 4    ; SPI Data Register bit 4
 .equ SPDR5 = 5    ; SPI Data Register bit 5
 .equ SPDR6 = 6    ; SPI Data Register bit 6
 .equ SPDR7 = 7    ; SPI Data Register bit 7

; SPSR - SPI Status Register
 .equ SPI2X = 0    ; Double SPI Speed Bit
 .equ WCOL = 6    ; Write Collision Flag
 .equ SPIF = 7    ; SPI Interrupt Flag

; SPCR - SPI Control Register
 .equ SPR0 = 0    ; SPI Clock Rate Select 0
 .equ SPR1 = 1    ; SPI Clock Rate Select 1
 .equ CPHA = 2    ; Clock Phase
 .equ CPOL = 3    ; Clock polarity
 .equ MSTR = 4    ; Master/Slave Select
 .equ DORD = 5    ; Data Order
 .equ SPE = 6    ; SPI Enable
 .equ SPIE = 7    ; SPI Interrupt Enable


; ***** TWI **************************
; TWBR - TWI Bit Rate register
 .equ I2BR = TWBR    ; For compatibility
 .equ TWBR0 = 0    ;
 .equ TWBR1 = 1    ;
 .equ TWBR2 = 2    ;
 .equ TWBR3 = 3    ;
 .equ TWBR4 = 4    ;
 .equ TWBR5 = 5    ;
 .equ TWBR6 = 6    ;
 .equ TWBR7 = 7    ;

; TWCR - TWI Control Register
 .equ I2CR = TWCR    ; For compatibility
 .equ TWIE = 0    ; TWI Interrupt Enable
 .equ I2IE = TWIE    ; For compatibility
 .equ TWEN = 2    ; TWI Enable Bit
 .equ I2EN = TWEN    ; For compatibility
 .equ ENI2C = TWEN    ; For compatibility
 .equ TWWC = 3    ; TWI Write Collition Flag
 .equ I2WC = TWWC    ; For compatibility
 .equ TWSTO = 4    ; TWI Stop Condition Bit
 .equ I2STO = TWSTO    ; For compatibility
 .equ TWSTA = 5    ; TWI Start Condition Bit
 .equ I2STA = TWSTA    ; For compatibility
 .equ TWEA = 6    ; TWI Enable Acknowledge Bit
 .equ I2EA = TWEA    ; For compatibility
 .equ TWINT = 7    ; TWI Interrupt Flag
 .equ I2INT = TWINT    ; For compatibility

; TWSR - TWI Status Register
 .equ I2SR = TWSR    ; For compatibility
 .equ TWPS0 = 0    ; TWI Prescaler
 .equ TWS0 = TWPS0    ; For compatibility
 .equ I2GCE = TWPS0    ; For compatibility
 .equ TWPS1 = 1    ; TWI Prescaler
 .equ TWS1 = TWPS1    ; For compatibility
 .equ TWS3 = 3    ; TWI Status
 .equ I2S3 = TWS3    ; For compatibility
 .equ TWS4 = 4    ; TWI Status
 .equ I2S4 = TWS4    ; For compatibility
 .equ TWS5 = 5    ; TWI Status
 .equ I2S5 = TWS5    ; For compatibility
 .equ TWS6 = 6    ; TWI Status
 .equ I2S6 = TWS6    ; For compatibility
 .equ TWS7 = 7    ; TWI Status
 .equ I2S7 = TWS7    ; For compatibility

; TWDR - TWI Data register
 .equ I2DR = TWDR    ; For compatibility
 .equ TWD0 = 0    ; TWI Data Register Bit 0
 .equ TWD1 = 1    ; TWI Data Register Bit 1
 .equ TWD2 = 2    ; TWI Data Register Bit 2
 .equ TWD3 = 3    ; TWI Data Register Bit 3
 .equ TWD4 = 4    ; TWI Data Register Bit 4
 .equ TWD5 = 5    ; TWI Data Register Bit 5
 .equ TWD6 = 6    ; TWI Data Register Bit 6
 .equ TWD7 = 7    ; TWI Data Register Bit 7

; TWAR - TWI (Slave) Address register
 .equ I2AR = TWAR    ; For compatibility
 .equ TWGCE = 0    ; TWI General Call Recognition Enable Bit
 .equ TWA0 = 1    ; TWI (Slave) Address register Bit 0
 .equ TWA1 = 2    ; TWI (Slave) Address register Bit 1
 .equ TWA2 = 3    ; TWI (Slave) Address register Bit 2
 .equ TWA3 = 4    ; TWI (Slave) Address register Bit 3
 .equ TWA4 = 5    ; TWI (Slave) Address register Bit 4
 .equ TWA5 = 6    ; TWI (Slave) Address register Bit 5
 .equ TWA6 = 7    ; TWI (Slave) Address register Bit 6


; ***** USART0 ***********************
; UDR0 - USART I/O Data Register
 .equ UDR00 = 0    ; USART I/O Data Register bit 0
 .equ UDR01 = 1    ; USART I/O Data Register bit 1
 .equ UDR02 = 2    ; USART I/O Data Register bit 2
 .equ UDR03 = 3    ; USART I/O Data Register bit 3
 .equ UDR04 = 4    ; USART I/O Data Register bit 4
 .equ UDR05 = 5    ; USART I/O Data Register bit 5
 .equ UDR06 = 6    ; USART I/O Data Register bit 6
 .equ UDR07 = 7    ; USART I/O Data Register bit 7

; UCSR0A - USART Control and Status Register A
 .equ MPCM0 = 0    ; Multi-processor Communication Mode
 .equ U2X0 = 1    ; Double the USART transmission speed
 .equ UPE0 = 2    ; Parity Error
 .equ DOR0 = 3    ; Data overRun
 .equ FE0 = 4    ; Framing Error
 .equ UDRE0 = 5    ; USART Data Register Empty
 .equ TXC0 = 6    ; USART Transmitt Complete
 .equ RXC0 = 7    ; USART Receive Complete

; UCSR0B - USART Control and Status Register B
 .equ TXB80 = 0    ; Transmit Data Bit 8
 .equ RXB80 = 1    ; Receive Data Bit 8
 .equ UCSZ02 = 2    ; Character Size
 .equ UCSZ2 = UCSZ02    ; For compatibility
 .equ TXEN0 = 3    ; Transmitter Enable
 .equ RXEN0 = 4    ; Receiver Enable
 .equ UDRIE0 = 5    ; USART Data register Empty Interrupt Enable
 .equ TXCIE0 = 6    ; TX Complete Interrupt Enable
 .equ RXCIE0 = 7    ; RX Complete Interrupt Enable

; UCSR0C - USART Control and Status Register C
 .equ UCPOL0 = 0    ; Clock Polarity
 .equ UCSZ00 = 1    ; Character Size
 .equ UCSZ01 = 2    ; Character Size
 .equ USBS0 = 3    ; Stop Bit Select
 .equ UPM00 = 4    ; Parity Mode Bit 0
 .equ UPM01 = 5    ; Parity Mode Bit 1
 .equ UMSEL0 = 6    ; USART Mode Select

; UBRR0H - USART Baud Rate Register Hight Byte
 .equ UBRR8 = 0    ; USART Baud Rate Register bit 8
 .equ UBRR9 = 1    ; USART Baud Rate Register bit 9
 .equ UBRR10 = 2    ; USART Baud Rate Register bit 10
 .equ UBRR11 = 3    ; USART Baud Rate Register bit 11

; UBRR0L - USART Baud Rate Register Low Byte
 .equ UBRR0 = 0    ; USART Baud Rate Register bit 0
 .equ UBRR1 = 1    ; USART Baud Rate Register bit 1
 .equ UBRR2 = 2    ; USART Baud Rate Register bit 2
 .equ UBRR3 = 3    ; USART Baud Rate Register bit 3
 .equ UBRR4 = 4    ; USART Baud Rate Register bit 4
 .equ UBRR5 = 5    ; USART Baud Rate Register bit 5
 .equ UBRR6 = 6    ; USART Baud Rate Register bit 6
 .equ UBRR7 = 7    ; USART Baud Rate Register bit 7


; ***** USART1 ***********************
; UDR1 - USART I/O Data Register
 .equ UDR10 = 0    ; USART I/O Data Register bit 0
 .equ UDR11 = 1    ; USART I/O Data Register bit 1
 .equ UDR12 = 2    ; USART I/O Data Register bit 2
 .equ UDR13 = 3    ; USART I/O Data Register bit 3
 .equ UDR14 = 4    ; USART I/O Data Register bit 4
 .equ UDR15 = 5    ; USART I/O Data Register bit 5
 .equ UDR16 = 6    ; USART I/O Data Register bit 6
 .equ UDR17 = 7    ; USART I/O Data Register bit 7

; UCSR1A - USART Control and Status Register A
 .equ MPCM1 = 0    ; Multi-processor Communication Mode
 .equ U2X1 = 1    ; Double the USART transmission speed
 .equ UPE1 = 2    ; Parity Error
 .equ DOR1 = 3    ; Data overRun
 .equ FE1 = 4    ; Framing Error
 .equ UDRE1 = 5    ; USART Data Register Empty
 .equ TXC1 = 6    ; USART Transmitt Complete
 .equ RXC1 = 7    ; USART Receive Complete

; UCSR1B - USART Control and Status Register B
 .equ TXB81 = 0    ; Transmit Data Bit 8
 .equ RXB81 = 1    ; Receive Data Bit 8
 .equ UCSZ12 = 2    ; Character Size
 .equ TXEN1 = 3    ; Transmitter Enable
 .equ RXEN1 = 4    ; Receiver Enable
 .equ UDRIE1 = 5    ; USART Data register Empty Interrupt Enable
 .equ TXCIE1 = 6    ; TX Complete Interrupt Enable
 .equ RXCIE1 = 7    ; RX Complete Interrupt Enable

; UCSR1C - USART Control and Status Register C
 .equ UCPOL1 = 0    ; Clock Polarity
 .equ UCSZ10 = 1    ; Character Size
 .equ UCSZ11 = 2    ; Character Size
 .equ USBS1 = 3    ; Stop Bit Select
 .equ UPM10 = 4    ; Parity Mode Bit 0
 .equ UPM11 = 5    ; Parity Mode Bit 1
 .equ UMSEL1 = 6    ; USART Mode Select

; UBRR1H - USART Baud Rate Register Hight Byte
;.equ    UBRR8    = 0    ; USART Baud Rate Register bit 8
;.equ    UBRR9    = 1    ; USART Baud Rate Register bit 9
;.equ    UBRR10    = 2    ; USART Baud Rate Register bit 10
;.equ    UBRR11    = 3    ; USART Baud Rate Register bit 11

; UBRR1L - USART Baud Rate Register Low Byte
;.equ    UBRR0    = 0    ; USART Baud Rate Register bit 0
;.equ    UBRR1    = 1    ; USART Baud Rate Register bit 1
;.equ    UBRR2    = 2    ; USART Baud Rate Register bit 2
;.equ    UBRR3    = 3    ; USART Baud Rate Register bit 3
;.equ    UBRR4    = 4    ; USART Baud Rate Register bit 4
;.equ    UBRR5    = 5    ; USART Baud Rate Register bit 5
;.equ    UBRR6    = 6    ; USART Baud Rate Register bit 6
;.equ    UBRR7    = 7    ; USART Baud Rate Register bit 7


; ***** CPU **************************
; SREG - Status Register
 .equ SREG_C = 0    ; Carry Flag
 .equ SREG_Z = 1    ; Zero Flag
 .equ SREG_N = 2    ; Negative Flag
 .equ SREG_V = 3    ; Two's Complement Overflow Flag
 .equ SREG_S = 4    ; Sign Bit
 .equ SREG_H = 5    ; Half Carry Flag
 .equ SREG_T = 6    ; Bit Copy Storage
 .equ SREG_I = 7    ; Global Interrupt Enable

; MCUCR - MCU Control Register
 .equ IVCE = 0    ; Interrupt Vector Change Enable
 .equ IVSEL = 1    ; Interrupt Vector Select
 .equ SM2 = 2    ; Sleep Mode Select
 .equ SM0 = 3    ; Sleep Mode Select
 .equ SM1 = 4    ; Sleep Mode Select
 .equ SE = 5    ; Sleep Enable
 .equ SRW10 = 6    ; External SRAM Wait State Select
 .equ SRE = 7    ; External SRAM Enable

; XMCRA - External Memory Control Register A
 .equ SRW11 = 1    ; Wait state select bit upper page
 .equ SRW00 = 2    ; Wait state select bit lower page
 .equ SRW01 = 3    ; Wait state select bit lower page
 .equ SRL0 = 4    ; Wait state page limit
 .equ SRL1 = 5    ; Wait state page limit
 .equ SRL2 = 6    ; Wait state page limit

; XMCRB - External Memory Control Register B
 .equ XMM0 = 0    ; External Memory High Mask
 .equ XMM1 = 1    ; External Memory High Mask
 .equ XMM2 = 2    ; External Memory High Mask
 .equ XMBK = 7    ; External Memory Bus Keeper Enable

; OSCCAL - Oscillator Calibration Value
 .equ CAL0 = 0    ; Oscillator Calibration Value
 .equ CAL1 = 1    ; Oscillator Calibration Value
 .equ CAL2 = 2    ; Oscillator Calibration Value
 .equ CAL3 = 3    ; Oscillator Calibration Value
 .equ CAL4 = 4    ; Oscillator Calibration Value
 .equ CAL5 = 5    ; Oscillator Calibration Value
 .equ CAL6 = 6    ; Oscillator Calibration Value
 .equ CAL7 = 7    ; Oscillator Calibration Value

; XDIV - XTAL Divide Control Register
 .equ XDIV0 = 0    ; XTAl Divide Select Bit 0
 .equ XDIV1 = 1    ; XTAl Divide Select Bit 1
 .equ XDIV2 = 2    ; XTAl Divide Select Bit 2
 .equ XDIV3 = 3    ; XTAl Divide Select Bit 3
 .equ XDIV4 = 4    ; XTAl Divide Select Bit 4
 .equ XDIV5 = 5    ; XTAl Divide Select Bit 5
 .equ XDIV6 = 6    ; XTAl Divide Select Bit 6
 .equ XDIVEN = 7    ; XTAL Divide Enable

; MCUCSR - MCU Control And Status Register
 .equ PORF = 0    ; Power-on reset flag
 .equ EXTRF = 1    ; External Reset Flag
 .equ BORF = 2    ; Brown-out Reset Flag
 .equ WDRF = 3    ; Watchdog Reset Flag
 .equ JTRF = 4    ; JTAG Reset Flag
 .equ JTD = 7    ; JTAG Interface Disable

; RAMPZ - RAM Page Z Select Register
 .equ RAMPZ0 = 0    ; RAM Page Z Select Register Bit 0


; ***** BOOT_LOAD ********************
; SPMCSR - Store Program Memory Control Register
 .equ SPMCR = SPMCSR    ; For compatibility
 .equ SPMEN = 0    ; Store Program Memory Enable
 .equ PGERS = 1    ; Page Erase
 .equ PGWRT = 2    ; Page Write
 .equ BLBSET = 3    ; Boot Lock Bit Set
 .equ RWWSRE = 4    ; Read While Write section read enable
 .equ ASRE = RWWSRE    ; For compatibility
 .equ RWWSB = 6    ; Read While Write Section Busy
 .equ ASB = RWWSB    ; For compatibility
 .equ SPMIE = 7    ; SPM Interrupt Enable


; ***** JTAG *************************
; OCDR - On-Chip Debug Related Register in I/O Memory
 .equ OCDR0 = 0    ; On-Chip Debug Register Bit 0
 .equ OCDR1 = 1    ; On-Chip Debug Register Bit 1
 .equ OCDR2 = 2    ; On-Chip Debug Register Bit 2
 .equ OCDR3 = 3    ; On-Chip Debug Register Bit 3
 .equ OCDR4 = 4    ; On-Chip Debug Register Bit 4
 .equ OCDR5 = 5    ; On-Chip Debug Register Bit 5
 .equ OCDR6 = 6    ; On-Chip Debug Register Bit 6
 .equ OCDR7 = 7    ; On-Chip Debug Register Bit 7
 .equ IDRD = OCDR7    ; For compatibility

; MCUCSR - MCU Control And Status Register
;.equ    JTRF    = 4    ; JTAG Reset Flag
;.equ    JTD    = 7    ; JTAG Interface Disable


; ***** MISC *************************
; SFIOR - Special Function IO Register
 .equ PSR321 = 0    ; Prescaler Reset Timer/Counter3, Timer/Counter2, and
 .equ PSR1 = PSR321    ; For compatibility
 .equ PSR2 = PSR321    ; For compatibility
 .equ PSR3 = PSR321    ; For compatibility
 .equ PSR0 = 1    ; Prescaler Reset Timer/Counter0
 .equ PUD = 2    ; Pull Up Disable
;.equ    ACME    = 3    ; Analog Comparator Multiplexer Enable
 .equ TSM = 7    ; Timer/Counter Synchronization Mode


; ***** EXTERNAL_INTERRUPT ***********
; EICRA - External Interrupt Control Register A
 .equ ISC00 = 0    ; External Interrupt Sense Control Bit
 .equ ISC01 = 1    ; External Interrupt Sense Control Bit
 .equ ISC10 = 2    ; External Interrupt Sense Control Bit
 .equ ISC11 = 3    ; External Interrupt Sense Control Bit
 .equ ISC20 = 4    ; External Interrupt Sense Control Bit
 .equ ISC21 = 5    ; External Interrupt Sense Control Bit
 .equ ISC30 = 6    ; External Interrupt Sense Control Bit
 .equ ISC31 = 7    ; External Interrupt Sense Control Bit

; EICRB - External Interrupt Control Register B
 .equ ISC40 = 0    ; External Interrupt 7-4 Sense Control Bit
 .equ ISC41 = 1    ; External Interrupt 7-4 Sense Control Bit
 .equ ISC50 = 2    ; External Interrupt 7-4 Sense Control Bit
 .equ ISC51 = 3    ; External Interrupt 7-4 Sense Control Bit
 .equ ISC60 = 4    ; External Interrupt 7-4 Sense Control Bit
 .equ ISC61 = 5    ; External Interrupt 7-4 Sense Control Bit
 .equ ISC70 = 6    ; External Interrupt 7-4 Sense Control Bit
 .equ ISC71 = 7    ; External Interrupt 7-4 Sense Control Bit

; EIMSK - External Interrupt Mask Register
 .equ GICR = EIMSK    ; For compatibility
 .equ GIMSK = EIMSK    ; For compatibility
 .equ INT0 = 0    ; External Interrupt Request 0 Enable
 .equ INT1 = 1    ; External Interrupt Request 1 Enable
 .equ INT2 = 2    ; External Interrupt Request 2 Enable
 .equ INT3 = 3    ; External Interrupt Request 3 Enable
 .equ INT4 = 4    ; External Interrupt Request 4 Enable
 .equ INT5 = 5    ; External Interrupt Request 5 Enable
 .equ INT6 = 6    ; External Interrupt Request 6 Enable
 .equ INT7 = 7    ; External Interrupt Request 7 Enable

; EIFR - External Interrupt Flag Register
 .equ GIFR = EIFR    ; For compatibility
 .equ INTF0 = 0    ; External Interrupt Flag 0
 .equ INTF1 = 1    ; External Interrupt Flag 1
 .equ INTF2 = 2    ; External Interrupt Flag 2
 .equ INTF3 = 3    ; External Interrupt Flag 3
 .equ INTF4 = 4    ; External Interrupt Flag 4
 .equ INTF5 = 5    ; External Interrupt Flag 5
 .equ INTF6 = 6    ; External Interrupt Flag 6
 .equ INTF7 = 7    ; External Interrupt Flag 7


; ***** EEPROM ***********************
; EEDR - EEPROM Data Register
 .equ EEDR0 = 0    ; EEPROM Data Register bit 0
 .equ EEDR1 = 1    ; EEPROM Data Register bit 1
 .equ EEDR2 = 2    ; EEPROM Data Register bit 2
 .equ EEDR3 = 3    ; EEPROM Data Register bit 3
 .equ EEDR4 = 4    ; EEPROM Data Register bit 4
 .equ EEDR5 = 5    ; EEPROM Data Register bit 5
 .equ EEDR6 = 6    ; EEPROM Data Register bit 6
 .equ EEDR7 = 7    ; EEPROM Data Register bit 7

; EECR - EEPROM Control Register
 .equ EERE = 0    ; EEPROM Read Enable
 .equ EEWE = 1    ; EEPROM Write Enable
 .equ EEMWE = 2    ; EEPROM Master Write Enable
 .equ EERIE = 3    ; EEPROM Ready Interrupt Enable


; ***** PORTA ************************
; PORTA - Port A Data Register
 .equ PORTA0 = 0    ; Port A Data Register bit 0
 .equ PA0 = 0    ; For compatibility
 .equ PORTA1 = 1    ; Port A Data Register bit 1
 .equ PA1 = 1    ; For compatibility
 .equ PORTA2 = 2    ; Port A Data Register bit 2
 .equ PA2 = 2    ; For compatibility
 .equ PORTA3 = 3    ; Port A Data Register bit 3
 .equ PA3 = 3    ; For compatibility
 .equ PORTA4 = 4    ; Port A Data Register bit 4
 .equ PA4 = 4    ; For compatibility
 .equ PORTA5 = 5    ; Port A Data Register bit 5
 .equ PA5 = 5    ; For compatibility
 .equ PORTA6 = 6    ; Port A Data Register bit 6
 .equ PA6 = 6    ; For compatibility
 .equ PORTA7 = 7    ; Port A Data Register bit 7
 .equ PA7 = 7    ; For compatibility

; DDRA - Port A Data Direction Register
 .equ DDA0 = 0    ; Data Direction Register, Port A, bit 0
 .equ DDA1 = 1    ; Data Direction Register, Port A, bit 1
 .equ DDA2 = 2    ; Data Direction Register, Port A, bit 2
 .equ DDA3 = 3    ; Data Direction Register, Port A, bit 3
 .equ DDA4 = 4    ; Data Direction Register, Port A, bit 4
 .equ DDA5 = 5    ; Data Direction Register, Port A, bit 5
 .equ DDA6 = 6    ; Data Direction Register, Port A, bit 6
 .equ DDA7 = 7    ; Data Direction Register, Port A, bit 7

; PINA - Port A Input Pins
 .equ PINA0 = 0    ; Input Pins, Port A bit 0
 .equ PINA1 = 1    ; Input Pins, Port A bit 1
 .equ PINA2 = 2    ; Input Pins, Port A bit 2
 .equ PINA3 = 3    ; Input Pins, Port A bit 3
 .equ PINA4 = 4    ; Input Pins, Port A bit 4
 .equ PINA5 = 5    ; Input Pins, Port A bit 5
 .equ PINA6 = 6    ; Input Pins, Port A bit 6
 .equ PINA7 = 7    ; Input Pins, Port A bit 7


; ***** PORTB ************************
; PORTB - Port B Data Register
 .equ PORTB0 = 0    ; Port B Data Register bit 0
 .equ PB0 = 0    ; For compatibility
 .equ PORTB1 = 1    ; Port B Data Register bit 1
 .equ PB1 = 1    ; For compatibility
 .equ PORTB2 = 2    ; Port B Data Register bit 2
 .equ PB2 = 2    ; For compatibility
 .equ PORTB3 = 3    ; Port B Data Register bit 3
 .equ PB3 = 3    ; For compatibility
 .equ PORTB4 = 4    ; Port B Data Register bit 4
 .equ PB4 = 4    ; For compatibility
 .equ PORTB5 = 5    ; Port B Data Register bit 5
 .equ PB5 = 5    ; For compatibility
 .equ PORTB6 = 6    ; Port B Data Register bit 6
 .equ PB6 = 6    ; For compatibility
 .equ PORTB7 = 7    ; Port B Data Register bit 7
 .equ PB7 = 7    ; For compatibility

; DDRB - Port B Data Direction Register
 .equ DDB0 = 0    ; Port B Data Direction Register bit 0
 .equ DDB1 = 1    ; Port B Data Direction Register bit 1
 .equ DDB2 = 2    ; Port B Data Direction Register bit 2
 .equ DDB3 = 3    ; Port B Data Direction Register bit 3
 .equ DDB4 = 4    ; Port B Data Direction Register bit 4
 .equ DDB5 = 5    ; Port B Data Direction Register bit 5
 .equ DDB6 = 6    ; Port B Data Direction Register bit 6
 .equ DDB7 = 7    ; Port B Data Direction Register bit 7

; PINB - Port B Input Pins
 .equ PINB0 = 0    ; Port B Input Pins bit 0
 .equ PINB1 = 1    ; Port B Input Pins bit 1
 .equ PINB2 = 2    ; Port B Input Pins bit 2
 .equ PINB3 = 3    ; Port B Input Pins bit 3
 .equ PINB4 = 4    ; Port B Input Pins bit 4
 .equ PINB5 = 5    ; Port B Input Pins bit 5
 .equ PINB6 = 6    ; Port B Input Pins bit 6
 .equ PINB7 = 7    ; Port B Input Pins bit 7


; ***** PORTC ************************
; PORTC - Port C Data Register
 .equ PORTC0 = 0    ; Port C Data Register bit 0
 .equ PC0 = 0    ; For compatibility
 .equ PORTC1 = 1    ; Port C Data Register bit 1
 .equ PC1 = 1    ; For compatibility
 .equ PORTC2 = 2    ; Port C Data Register bit 2
 .equ PC2 = 2    ; For compatibility
 .equ PORTC3 = 3    ; Port C Data Register bit 3
 .equ PC3 = 3    ; For compatibility
 .equ PORTC4 = 4    ; Port C Data Register bit 4
 .equ PC4 = 4    ; For compatibility
 .equ PORTC5 = 5    ; Port C Data Register bit 5
 .equ PC5 = 5    ; For compatibility
 .equ PORTC6 = 6    ; Port C Data Register bit 6
 .equ PC6 = 6    ; For compatibility
 .equ PORTC7 = 7    ; Port C Data Register bit 7
 .equ PC7 = 7    ; For compatibility

; DDRC - Port C Data Direction Register
 .equ DDC0 = 0    ; Port C Data Direction Register bit 0
 .equ DDC1 = 1    ; Port C Data Direction Register bit 1
 .equ DDC2 = 2    ; Port C Data Direction Register bit 2
 .equ DDC3 = 3    ; Port C Data Direction Register bit 3
 .equ DDC4 = 4    ; Port C Data Direction Register bit 4
 .equ DDC5 = 5    ; Port C Data Direction Register bit 5
 .equ DDC6 = 6    ; Port C Data Direction Register bit 6
 .equ DDC7 = 7    ; Port C Data Direction Register bit 7

; PINC - Port C Input Pins
 .equ PINC0 = 0    ; Port C Input Pins bit 0
 .equ PINC1 = 1    ; Port C Input Pins bit 1
 .equ PINC2 = 2    ; Port C Input Pins bit 2
 .equ PINC3 = 3    ; Port C Input Pins bit 3
 .equ PINC4 = 4    ; Port C Input Pins bit 4
 .equ PINC5 = 5    ; Port C Input Pins bit 5
 .equ PINC6 = 6    ; Port C Input Pins bit 6
 .equ PINC7 = 7    ; Port C Input Pins bit 7


; ***** PORTD ************************
; PORTD - Port D Data Register
 .equ PORTD0 = 0    ; Port D Data Register bit 0
 .equ PD0 = 0    ; For compatibility
 .equ PORTD1 = 1    ; Port D Data Register bit 1
 .equ PD1 = 1    ; For compatibility
 .equ PORTD2 = 2    ; Port D Data Register bit 2
 .equ PD2 = 2    ; For compatibility
 .equ PORTD3 = 3    ; Port D Data Register bit 3
 .equ PD3 = 3    ; For compatibility
 .equ PORTD4 = 4    ; Port D Data Register bit 4
 .equ PD4 = 4    ; For compatibility
 .equ PORTD5 = 5    ; Port D Data Register bit 5
 .equ PD5 = 5    ; For compatibility
 .equ PORTD6 = 6    ; Port D Data Register bit 6
 .equ PD6 = 6    ; For compatibility
 .equ PORTD7 = 7    ; Port D Data Register bit 7
 .equ PD7 = 7    ; For compatibility

; DDRD - Port D Data Direction Register
 .equ DDD0 = 0    ; Port D Data Direction Register bit 0
 .equ DDD1 = 1    ; Port D Data Direction Register bit 1
 .equ DDD2 = 2    ; Port D Data Direction Register bit 2
 .equ DDD3 = 3    ; Port D Data Direction Register bit 3
 .equ DDD4 = 4    ; Port D Data Direction Register bit 4
 .equ DDD5 = 5    ; Port D Data Direction Register bit 5
 .equ DDD6 = 6    ; Port D Data Direction Register bit 6
 .equ DDD7 = 7    ; Port D Data Direction Register bit 7

; PIND - Port D Input Pins
 .equ PIND0 = 0    ; Port D Input Pins bit 0
 .equ PIND1 = 1    ; Port D Input Pins bit 1
 .equ PIND2 = 2    ; Port D Input Pins bit 2
 .equ PIND3 = 3    ; Port D Input Pins bit 3
 .equ PIND4 = 4    ; Port D Input Pins bit 4
 .equ PIND5 = 5    ; Port D Input Pins bit 5
 .equ PIND6 = 6    ; Port D Input Pins bit 6
 .equ PIND7 = 7    ; Port D Input Pins bit 7


; ***** PORTE ************************
; PORTE - Data Register, Port E
 .equ PORTE0 = 0    ;
 .equ PE0 = 0    ; For compatibility
 .equ PORTE1 = 1    ;
 .equ PE1 = 1    ; For compatibility
 .equ PORTE2 = 2    ;
 .equ PE2 = 2    ; For compatibility
 .equ PORTE3 = 3    ;
 .equ PE3 = 3    ; For compatibility
 .equ PORTE4 = 4    ;
 .equ PE4 = 4    ; For compatibility
 .equ PORTE5 = 5    ;
 .equ PE5 = 5    ; For compatibility
 .equ PORTE6 = 6    ;
 .equ PE6 = 6    ; For compatibility
 .equ PORTE7 = 7    ;
 .equ PE7 = 7    ; For compatibility

; DDRE - Data Direction Register, Port E
 .equ DDE0 = 0    ;
 .equ DDE1 = 1    ;
 .equ DDE2 = 2    ;
 .equ DDE3 = 3    ;
 .equ DDE4 = 4    ;
 .equ DDE5 = 5    ;
 .equ DDE6 = 6    ;
 .equ DDE7 = 7    ;

; PINE - Input Pins, Port E
 .equ PINE0 = 0    ;
 .equ PINE1 = 1    ;
 .equ PINE2 = 2    ;
 .equ PINE3 = 3    ;
 .equ PINE4 = 4    ;
 .equ PINE5 = 5    ;
 .equ PINE6 = 6    ;
 .equ PINE7 = 7    ;


; ***** PORTF ************************
; PORTF - Data Register, Port F
 .equ PORTF0 = 0    ;
 .equ PF0 = 0    ; For compatibility
 .equ PORTF1 = 1    ;
 .equ PF1 = 1    ; For compatibility
 .equ PORTF2 = 2    ;
 .equ PF2 = 2    ; For compatibility
 .equ PORTF3 = 3    ;
 .equ PF3 = 3    ; For compatibility
 .equ PORTF4 = 4    ;
 .equ PF4 = 4    ; For compatibility
 .equ PORTF5 = 5    ;
 .equ PF5 = 5    ; For compatibility
 .equ PORTF6 = 6    ;
 .equ PF6 = 6    ; For compatibility
 .equ PORTF7 = 7    ;
 .equ PF7 = 7    ; For compatibility

; DDRF - Data Direction Register, Port F
 .equ DDF0 = 0    ;
 .equ DDF1 = 1    ;
 .equ DDF2 = 2    ;
 .equ DDF3 = 3    ;
 .equ DDF4 = 4    ;
 .equ DDF5 = 5    ;
 .equ DDF6 = 6    ;
 .equ DDF7 = 7    ;

; PINF - Input Pins, Port F
 .equ PINF0 = 0    ;
 .equ PINF1 = 1    ;
 .equ PINF2 = 2    ;
 .equ PINF3 = 3    ;
 .equ PINF4 = 4    ;
 .equ PINF5 = 5    ;
 .equ PINF6 = 6    ;
 .equ PINF7 = 7    ;


; ***** PORTG ************************
; PORTG - Data Register, Port G
 .equ PORTG0 = 0    ;
 .equ PG0 = 0    ; For compatibility
 .equ PORTG1 = 1    ;
 .equ PG1 = 1    ; For compatibility
 .equ PORTG2 = 2    ;
 .equ PG2 = 2    ; For compatibility
 .equ PORTG3 = 3    ;
 .equ PG3 = 3    ; For compatibility
 .equ PORTG4 = 4    ;
 .equ PG4 = 4    ; For compatibility

; DDRG - Data Direction Register, Port G
 .equ DDG0 = 0    ;
 .equ DDG1 = 1    ;
 .equ DDG2 = 2    ;
 .equ DDG3 = 3    ;
 .equ DDG4 = 4    ;

; PING - Input Pins, Port G
 .equ PING0 = 0    ;
 .equ PING1 = 1    ;
 .equ PING2 = 2    ;
 .equ PING3 = 3    ;
 .equ PING4 = 4    ;


; ***** TIMER_COUNTER_0 **************
; TCCR0 - Timer/Counter Control Register
 .equ CS00 = 0    ; Clock Select 0
 .equ CS01 = 1    ; Clock Select 1
 .equ CS02 = 2    ; Clock Select 2
 .equ WGM01 = 3    ; Waveform Generation Mode 1
 .equ CTC0 = WGM01    ; For compatibility
 .equ COM00 = 4    ; Compare match Output Mode 0
 .equ COM01 = 5    ; Compare Match Output Mode 1
 .equ WGM00 = 6    ; Waveform Generation Mode 0
 .equ PWM0 = WGM00    ; For compatibility
 .equ FOC0 = 7    ; Force Output Compare

; TCNT0 - Timer/Counter Register
 .equ TCNT0_0 = 0    ;
 .equ TCNT0_1 = 1    ;
 .equ TCNT0_2 = 2    ;
 .equ TCNT0_3 = 3    ;
 .equ TCNT0_4 = 4    ;
 .equ TCNT0_5 = 5    ;
 .equ TCNT0_6 = 6    ;
 .equ TCNT0_7 = 7    ;

; OCR0 - Output Compare Register
 .equ OCR0_0 = 0    ;
 .equ OCR0_1 = 1    ;
 .equ OCR0_2 = 2    ;
 .equ OCR0_3 = 3    ;
 .equ OCR0_4 = 4    ;
 .equ OCR0_5 = 5    ;
 .equ OCR0_6 = 6    ;
 .equ OCR0_7 = 7    ;

; ASSR - Asynchronus Status Register
 .equ TCR0UB = 0    ; Timer/Counter Control Register 0 Update Busy
 .equ OCR0UB = 1    ; Output Compare register 0 Busy
 .equ TCN0UB = 2    ; Timer/Counter0 Update Busy
 .equ AS0 = 3    ; Asynchronus Timer/Counter 0

; TIMSK - Timer/Counter Interrupt Mask Register
 .equ TOIE0 = 0    ; Timer/Counter0 Overflow Interrupt Enable
 .equ OCIE0 = 1    ; Timer/Counter0 Output Compare Match Interrupt regist

; TIFR - Timer/Counter Interrupt Flag register
 .equ TOV0 = 0    ; Timer/Counter0 Overflow Flag
 .equ OCF0 = 1    ; Output Compare Flag 0

; SFIOR - Special Function IO Register
;.equ    PSR0    = 1    ; Prescaler Reset Timer/Counter0
;.equ    TSM    = 7    ; Timer/Counter Synchronization Mode


; ***** TIMER_COUNTER_1 **************
; TIMSK - Timer/Counter Interrupt Mask Register
 .equ TOIE1 = 2    ; Timer/Counter1 Overflow Interrupt Enable
 .equ OCIE1B = 3    ; Timer/Counter1 Output CompareB Match Interrupt Enab
 .equ OCIE1A = 4    ; Timer/Counter1 Output CompareA Match Interrupt Enab
 .equ TICIE1 = 5    ; Timer/Counter1 Input Capture Interrupt Enable

; ETIMSK - Extended Timer/Counter Interrupt Mask Register
 .equ OCIE1C = 0    ; Timer/Counter 1, Output Compare Match C Interrupt E

; TIFR - Timer/Counter Interrupt Flag register
 .equ TOV1 = 2    ; Timer/Counter1 Overflow Flag
 .equ OCF1B = 3    ; Output Compare Flag 1B
 .equ OCF1A = 4    ; Output Compare Flag 1A
 .equ ICF1 = 5    ; Input Capture Flag 1

; ETIFR - Extended Timer/Counter Interrupt Flag register
 .equ OCF1C = 0    ; Timer/Counter 1, Output Compare C Match Flag

; SFIOR - Special Function IO Register
;.equ    PSR321    = 0    ; Prescaler Reset, T/C3, T/C2, T/C1
;.equ    TSM    = 7    ; Timer/Counter Synchronization Mode

; TCCR1A - Timer/Counter1 Control Register A
 .equ WGM10 = 0    ; Waveform Generation Mode Bit 0
 .equ PWM10 = WGM10    ; For compatibility
 .equ WGM11 = 1    ; Waveform Generation Mode Bit 1
 .equ PWM11 = WGM11    ; For compatibility
 .equ COM1C0 = 2    ; Compare Output Mode 1C, bit 0
 .equ COM1C1 = 3    ; Compare Output Mode 1C, bit 1
 .equ COM1B0 = 4    ; Compare Output Mode 1B, bit 0
 .equ COM1B1 = 5    ; Compare Output Mode 1B, bit 1
 .equ COM1A0 = 6    ; Compare Ouput Mode 1A, bit 0
 .equ COM1A1 = 7    ; Compare Output Mode 1A, bit 1

; TCCR1B - Timer/Counter1 Control Register B
 .equ CS10 = 0    ; Clock Select bit 0
 .equ CS11 = 1    ; Clock Select 1 bit 1
 .equ CS12 = 2    ; Clock Select1 bit 2
 .equ WGM12 = 3    ; Waveform Generation Mode
 .equ CTC10 = WGM12    ; For compatibility
 .equ WGM13 = 4    ; Waveform Generation Mode
 .equ CTC11 = WGM13    ; For compatibility
 .equ ICES1 = 6    ; Input Capture 1 Edge Select
 .equ ICNC1 = 7    ; Input Capture 1 Noise Canceler

; TCCR1C - Timer/Counter1 Control Register C
 .equ FOC1C = 5    ; Force Output Compare for channel C
 .equ FOC1B = 6    ; Force Output Compare for channel B
 .equ FOC1A = 7    ; Force Output Compare for channel A


; ***** TIMER_COUNTER_2 **************
; TCCR2 - Timer/Counter Control Register
 .equ CS20 = 0    ; Clock Select
 .equ CS21 = 1    ; Clock Select
 .equ CS22 = 2    ; Clock Select
 .equ WGM21 = 3    ; Waveform Generation Mode
 .equ CTC2 = WGM21    ; For compatibility
 .equ COM20 = 4    ; Compare Match Output Mode
 .equ COM21 = 5    ; Compare Match Output Mode
 .equ WGM20 = 6    ; Wafeform Generation Mode
 .equ PWM2 = WGM20    ; For compatibility
 .equ FOC2 = 7    ; Force Output Compare

; TCNT2 - Timer/Counter Register
 .equ TCNT2_0 = 0    ; Timer/Counter Register Bit 0
 .equ TCNT2_1 = 1    ; Timer/Counter Register Bit 1
 .equ TCNT2_2 = 2    ; Timer/Counter Register Bit 2
 .equ TCNT2_3 = 3    ; Timer/Counter Register Bit 3
 .equ TCNT2_4 = 4    ; Timer/Counter Register Bit 4
 .equ TCNT2_5 = 5    ; Timer/Counter Register Bit 5
 .equ TCNT2_6 = 6    ; Timer/Counter Register Bit 6
 .equ TCNT2_7 = 7    ; Timer/Counter Register Bit 7

; OCR2 - Output Compare Register
 .equ OCR2_0 = 0    ; Output Compare Register Bit 0
 .equ OCR2_1 = 1    ; Output Compare Register Bit 1
 .equ OCR2_2 = 2    ; Output Compare Register Bit 2
 .equ OCR2_3 = 3    ; Output Compare Register Bit 3
 .equ OCR2_4 = 4    ; Output Compare Register Bit 4
 .equ OCR2_5 = 5    ; Output Compare Register Bit 5
 .equ OCR2_6 = 6    ; Output Compare Register Bit 6
 .equ OCR2_7 = 7    ; Output Compare Register Bit 7

; TIMSK -
 .equ TOIE2 = 6    ;
 .equ OCIE2 = 7    ;

; TIFR - Timer/Counter Interrupt Flag Register
 .equ TOV2 = 6    ; Timer/Counter2 Overflow Flag
 .equ OCF2 = 7    ; Output Compare Flag 2


; ***** TIMER_COUNTER_3 **************
; ETIMSK - Extended Timer/Counter Interrupt Mask Register
 .equ OCIE3C = 1    ; Timer/Counter3, Output Compare Match Interrupt Enab
 .equ TOIE3 = 2    ; Timer/Counter3 Overflow Interrupt Enable
 .equ OCIE3B = 3    ; Timer/Counter3 Output CompareB Match Interrupt Enab
 .equ OCIE3A = 4    ; Timer/Counter3 Output CompareA Match Interrupt Enab
 .equ TICIE3 = 5    ; Timer/Counter3 Input Capture Interrupt Enable

; ETIFR - Extended Timer/Counter Interrupt Flag register
 .equ OCF3C = 1    ; Timer/Counter3 Output Compare C Match Flag
 .equ TOV3 = 2    ; Timer/Counter3 Overflow Flag
 .equ OCF3B = 3    ; Output Compare Flag 1B
 .equ OCF3A = 4    ; Output Compare Flag 1A
 .equ ICF3 = 5    ; Input Capture Flag 1

; SFIOR - Special Function IO Register
;.equ    PSR321    = 0    ; Prescaler Reset, T/C3, T/C2, T/C1
;.equ    PSR1    = PSR321    ; For compatibility
;.equ    PSR2    = PSR321    ; For compatibility
;.equ    TSM    = 7    ; Timer/Counter Synchronization Mode

; TCCR3A - Timer/Counter3 Control Register A
 .equ WGM30 = 0    ; Waveform Generation Mode Bit 0
 .equ PWM30 = WGM30    ; For compatibility
 .equ WGM31 = 1    ; Waveform Generation Mode Bit 1
 .equ PWM31 = WGM31    ; For compatibility
 .equ COM3C0 = 2    ; Compare Output Mode 3C, bit 0
 .equ COM3C1 = 3    ; Compare Output Mode 3C, bit 1
 .equ COM3B0 = 4    ; Compare Output Mode 3B, bit 0
 .equ COM3B1 = 5    ; Compare Output Mode 3B, bit 1
 .equ COM3A0 = 6    ; Comparet Ouput Mode 3A, bit 0
 .equ COM3A1 = 7    ; Compare Output Mode 3A, bit 1

; TCCR3B - Timer/Counter3 Control Register B
 .equ CS30 = 0    ; Clock Select 3 bit 0
 .equ CS31 = 1    ; Clock Select 3 bit 1
 .equ CS32 = 2    ; Clock Select3 bit 2
 .equ WGM32 = 3    ; Waveform Generation Mode
 .equ CTC30 = WGM32    ; For compatibility
 .equ WGM33 = 4    ; Waveform Generation Mode
 .equ CTC31 = WGM33    ; For compatibility
 .equ ICES3 = 6    ; Input Capture 3 Edge Select
 .equ ICNC3 = 7    ; Input Capture 3  Noise Canceler

; TCCR3C - Timer/Counter3 Control Register C
 .equ FOC3C = 5    ; Force Output Compare for channel C
 .equ FOC3B = 6    ; Force Output Compare for channel B
 .equ FOC3A = 7    ; Force Output Compare for channel A

; TCNT3L - Timer/Counter3 Low Byte
 .equ TCN3L0 = 0    ; Timer/Counter 3 bit 0
 .equ TCN3L1 = 1    ; Timer/Counter 3 bit 1
 .equ TCN3L2 = 2    ; Timer/Counter 3 bit 2
 .equ TCN3L3 = 3    ; Timer/Counter 3 bit 3
 .equ TCN3L4 = 4    ; Timer/Counter 3 bit 4
 .equ TCN3L5 = 5    ; Timer/Counter 3 bit 5
 .equ TCN3L6 = 6    ; Timer/Counter 3 bit 6
 .equ TCN3L7 = 7    ; Timer/Counter 3 bit 7


; ***** WATCHDOG *********************
; WDTCR - Watchdog Timer Control Register
 .equ WDTCSR = WDTCR    ; For compatibility
 .equ WDP0 = 0    ; Watch Dog Timer Prescaler bit 0
 .equ WDP1 = 1    ; Watch Dog Timer Prescaler bit 1
 .equ WDP2 = 2    ; Watch Dog Timer Prescaler bit 2
 .equ WDE = 3    ; Watch Dog Enable
 .equ WDCE = 4    ; Watchdog Change Enable
 .equ WDTOE = WDCE    ; For compatibility


; ***** AD_CONVERTER *****************
; ADMUX - The ADC multiplexer Selection Register
 .equ MUX0 = 0    ; Analog Channel and Gain Selection Bits
 .equ MUX1 = 1    ; Analog Channel and Gain Selection Bits
 .equ MUX2 = 2    ; Analog Channel and Gain Selection Bits
 .equ MUX3 = 3    ; Analog Channel and Gain Selection Bits
 .equ MUX4 = 4    ; Analog Channel and Gain Selection Bits
 .equ ADLAR = 5    ; Left Adjust Result
 .equ REFS0 = 6    ; Reference Selection Bit 0
 .equ REFS1 = 7    ; Reference Selection Bit 1

; ADCSRA - The ADC Control and Status register
 .equ ADCSR = ADCSRA    ; For compatibility
 .equ ADPS0 = 0    ; ADC  Prescaler Select Bits
 .equ ADPS1 = 1    ; ADC  Prescaler Select Bits
 .equ ADPS2 = 2    ; ADC  Prescaler Select Bits
 .equ ADIE = 3    ; ADC Interrupt Enable
 .equ ADIF = 4    ; ADC Interrupt Flag
 .equ ADFR = 5    ; ADC  Free Running Select
 .equ ADSC = 6    ; ADC Start Conversion
 .equ ADEN = 7    ; ADC Enable

; ADCH - ADC Data Register High Byte
 .equ ADCH0 = 0    ; ADC Data Register High Byte Bit 0
 .equ ADCH1 = 1    ; ADC Data Register High Byte Bit 1
 .equ ADCH2 = 2    ; ADC Data Register High Byte Bit 2
 .equ ADCH3 = 3    ; ADC Data Register High Byte Bit 3
 .equ ADCH4 = 4    ; ADC Data Register High Byte Bit 4
 .equ ADCH5 = 5    ; ADC Data Register High Byte Bit 5
 .equ ADCH6 = 6    ; ADC Data Register High Byte Bit 6
 .equ ADCH7 = 7    ; ADC Data Register High Byte Bit 7

; ADCL - ADC Data Register Low Byte
 .equ ADCL0 = 0    ; ADC Data Register Low Byte Bit 0
 .equ ADCL1 = 1    ; ADC Data Register Low Byte Bit 1
 .equ ADCL2 = 2    ; ADC Data Register Low Byte Bit 2
 .equ ADCL3 = 3    ; ADC Data Register Low Byte Bit 3
 .equ ADCL4 = 4    ; ADC Data Register Low Byte Bit 4
 .equ ADCL5 = 5    ; ADC Data Register Low Byte Bit 5
 .equ ADCL6 = 6    ; ADC Data Register Low Byte Bit 6
 .equ ADCL7 = 7    ; ADC Data Register Low Byte Bit 7



; ***** LOCKSBITS ********************************************************
 .equ LB1 = 0    ; Lock bit
 .equ LB2 = 1    ; Lock bit
 .equ BLB01 = 2    ; Boot Lock bit
 .equ BLB02 = 3    ; Boot Lock bit
 .equ BLB11 = 4    ; Boot lock bit
 .equ BLB12 = 5    ; Boot lock bit


; ***** FUSES ************************************************************
; LOW fuse bits
 .equ CKSEL0 = 0    ; Select Clock Source
 .equ CKSEL1 = 1    ; Select Clock Source
 .equ CKSEL2 = 2    ; Select Clock Source
 .equ CKSEL3 = 3    ; Select Clock Source
 .equ SUT0 = 4    ; Select start-up time
 .equ SUT1 = 5    ; Select start-up time
 .equ BODEN = 6    ; Brown out detector enable
 .equ BODLEVEL = 7    ; Brown out detector trigger level

; HIGH fuse bits
 .equ BOOTRST = 0    ; Select Reset Vector
 .equ BOOTSZ0 = 1    ; Select Boot Size
 .equ BOOTSZ1 = 2    ; Select Boot Size
 .equ EESAVE = 3    ; EEPROM memory is preserved through chip erase
 .equ CKOPT = 4    ; Oscillator Options
 .equ SPIEN = 5    ; Enable Serial programming and Data Downloading
 .equ JTAGEN = 6    ; Enable JTAG
 .equ OCDEN = 7    ; Enable OCD

; EXTENDED fuse bits
 .equ WDTON = 0    ; Watchdog timer always on
 .equ M103C = 1    ; ATmega103 compatibility mode



; ***** CPU REGISTER DEFINITIONS *****************************************
;.def    XH    = r27
;.def    XL    = r26
;.def    YH    = r29
;.def    YL    = r28
;.def    ZH    = r31
;.def    ZL    = r30



; ***** DATA MEMORY DECLARATIONS *****************************************
 .equ FLASHEND = 0xffff    ; Note: Word address
 .equ IOEND = 0x00ff
 .equ SRAM_START = 0x0100
 .equ SRAM_SIZE = 4096
 .equ RAMEND = 0x10ff
 .equ XRAMEND = 0xffff
 .equ E2END = 0x0fff
 .equ EEPROMEND = 0x0fff
 .equ EEADRBITS = 12
;#pragma AVRPART MEMORY PROG_FLASH 131072
;#pragma AVRPART MEMORY EEPROM 4096
;#pragma AVRPART MEMORY INT_SRAM SIZE 4096
;#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100



; ***** BOOTLOADER DECLARATIONS ******************************************
 .equ NRWW_START_ADDR = 0xf000
 .equ NRWW_STOP_ADDR = 0xffff
 .equ RWW_START_ADDR = 0x0
 .equ RWW_STOP_ADDR = 0xefff
 .equ PAGESIZE = 128
 .equ FIRSTBOOTSTART = 0xfe00
 .equ SECONDBOOTSTART = 0xfc00
 .equ THIRDBOOTSTART = 0xf800
 .equ FOURTHBOOTSTART = 0xf000
 .equ SMALLBOOTSTART = FIRSTBOOTSTART
 .equ LARGEBOOTSTART = FOURTHBOOTSTART



; ***** INTERRUPT VECTORS ************************************************
 .equ INT0addr = 0x0002    ; External Interrupt Request 0
 .equ INT1addr = 0x0004    ; External Interrupt Request 1
 .equ INT2addr = 0x0006    ; External Interrupt Request 2
 .equ INT3addr = 0x0008    ; External Interrupt Request 3
 .equ INT4addr = 0x000a    ; External Interrupt Request 4
 .equ INT5addr = 0x000c    ; External Interrupt Request 5
 .equ INT6addr = 0x000e    ; External Interrupt Request 6
 .equ INT7addr = 0x0010    ; External Interrupt Request 7
 .equ OC2addr = 0x0012    ; Timer/Counter2 Compare Match
 .equ OVF2addr = 0x0014    ; Timer/Counter2 Overflow
 .equ ICP1addr = 0x0016    ; Timer/Counter1 Capture Event
 .equ OC1Aaddr = 0x0018    ; Timer/Counter1 Compare Match A
 .equ OC1Baddr = 0x001a    ; Timer/Counter Compare Match B
 .equ OVF1addr = 0x001c    ; Timer/Counter1 Overflow
 .equ OC0addr = 0x001e    ; Timer/Counter0 Compare Match
 .equ OVF0addr = 0x0020    ; Timer/Counter0 Overflow
 .equ SPIaddr = 0x0022    ; SPI Serial Transfer Complete
 .equ URXC0addr = 0x0024    ; USART0, Rx Complete
 .equ UDRE0addr = 0x0026    ; USART0 Data Register Empty
 .equ UTXC0addr = 0x0028    ; USART0, Tx Complete
 .equ ADCCaddr = 0x002a    ; ADC Conversion Complete
 .equ ERDYaddr = 0x002c    ; EEPROM Ready
 .equ ACIaddr = 0x002e    ; Analog Comparator
 .equ OC1Caddr = 0x0030    ; Timer/Counter1 Compare Match C
 .equ ICP3addr = 0x0032    ; Timer/Counter3 Capture Event
 .equ OC3Aaddr = 0x0034    ; Timer/Counter3 Compare Match A
 .equ OC3Baddr = 0x0036    ; Timer/Counter3 Compare Match B
 .equ OC3Caddr = 0x0038    ; Timer/Counter3 Compare Match C
 .equ OVF3addr = 0x003a    ; Timer/Counter3 Overflow
 .equ URXC1addr = 0x003c    ; USART1, Rx Complete
 .equ UDRE1addr = 0x003e    ; USART1, Data Register Empty
 .equ UTXC1addr = 0x0040    ; USART1, Tx Complete
 .equ TWIaddr = 0x0042    ; 2-wire Serial Interface
 .equ SPMRaddr = 0x0044    ; Store Program Memory Read

 .equ INT_VECTORS_SIZE = 70    ; size in words

;#endif  /* _M128DEF_INC_ */

; ***** END OF FILE ******************************************************

 SetAsmDefinitions:

    ret
 .endif
;-------------------------------------------------
 .ifdef TagSetAsmDefinitions128Can

;***************************************************************************
;* A P P L I C A T I O N   N O T E   F O R   T H E   A V R   F A M I L Y
;*
;* Number         : AVR000
;* File Name      : "can128def.inc"
;* Title          : Register/Bit Definitions for the AT90CAN128
;* Date           : March 15th, 2004
;* Version        : 1.0.4
;* Support tel    : -
;* Support Web    : http://www.atmel.com/dyn/products/tech_support.asp?Faq=y
;* Target MCU     : AT90CAN128
;*
;* DESCRIPTION
;* When including this file in the assembly program file, all I/O register
;* names and I/O register bit names appearing in the data book can be used.
;* In addition, the six registers forming the three data pointers X, Y and
;* Z have been assigned names XL - ZH. Highest RAM address for Internal
;* SRAM is also defined.
;*
;* The Register names are represented by their hexadecimal address.
;*
;* The Register Bit names are represented by their bit number (0-7).
;*
;* Please observe the difference in using the bit names with instructions
;* such as "sbr"/"cbr" (set/clear bit in register) and "sbrs"/"sbrc" (skip
;* if bit in register set/cleared). The following example illustrates this:
;*
;* in   r16,PORTB             ; read PORTB latch
;* sbr  r16,(1<<PB6)+(1<<PB5) ; set PB6 and PB5 (use masks, not bit#)
;* out  PORTB,r16             ; output to PORTB
;*
;* in   r16,TIFR0             ; read the Timer Interrupt Flag Register
;* sbrc r16,TOV0              ; test the overflow flag (use bit#)
;* rjmp TOV0_is_set           ; jump if set
;* ...                        ; otherwise do something else
;*
;***************************************************************************

;**** Specify Device ****
;.device AT90CAN128



;***************************************************************************
; I/O Register Definitions
;***************************************************************************

;**** Memory Mapped I/O Register Definitions  ****

; *** C.A.N ***
.equ  CANMSG    = $FA
.equ  CANSTMH   = $F9
.equ  CANSTML   = $F8
.equ  CANIDM1   = $F7
.equ  CANIDM2   = $F6
.equ  CANIDM3   = $F5
.equ  CANIDM4   = $F4
.equ  CANIDT1   = $F3
.equ  CANIDT2   = $F2
.equ  CANIDT3   = $F1
.equ  CANIDT4   = $F0
.equ  CANCDMOB  = $EF
.equ  CANSTMOB  = $EE
.equ  CANPAGE   = $ED
.equ  CANHPMOB  = $EC
.equ  CANREC    = $EB
.equ  CANTEC    = $EA
.equ  CANTTCH   = $E9
.equ  CANTTCL   = $E8
.equ  CANTIMH   = $E7
.equ  CANTIML   = $E6
.equ  CANTCON   = $E5
.equ  CANBT3    = $E4
.equ  CANBT2    = $E3
.equ  CANBT1    = $E2
.equ  CANSIT1   = $E1
.equ  CANSIT2   = $E0
.equ  CANIE1    = $DF
.equ  CANIE2    = $DE
.equ  CANEN1    = $DD
.equ  CANEN2    = $DC
.equ  CANGIE    = $DB
.equ  CANGIT    = $DA
.equ  CANGSTA   = $D9
.equ  CANGCON   = $D8

; *** USART1 ***
.equ  UDR1      = $CE
.equ  UBRR1H    = $CD
.equ  UBRR1L    = $CC
.equ  UCSR1C    = $CA
.equ  UCSR1B    = $C9
.equ  UCSR1A    = $C8

; *** USART0 ***
.equ  UDR0      = $C6
.equ  UBRR0H    = $C5
.equ  UBRR0L    = $C4
.equ  UCSR0C    = $C2
.equ  UCSR0B    = $C1
.equ  UCSR0A    = $C0

; *** T.W.I ***
.equ  TWCR      = $BC
.equ  TWDR      = $BB
.equ  TWAR      = $BA
.equ  TWSR      = $B9
.equ  TWBR      = $B8

; *** TIMER-2 (Async) ***
.equ  ASSR      = $B6
.equ  OCR2A     = $B3
.equ  TCNT2     = $B2
.equ  TCCR2A    = $B0

; *** TIMER-3 ***
.equ  OCR3CH    = $9D
.equ  OCR3CL    = $9C
.equ  OCR3BH    = $9B
.equ  OCR3BL    = $9A
.equ  OCR3AH    = $99
.equ  OCR3AL    = $98
.equ  ICR3H     = $87
.equ  ICR3L     = $96
.equ  TCNT3H    = $95
.equ  TCNT3L    = $94
.equ  TCCR3C    = $92
.equ  TCCR3B    = $91
.equ  TCCR3A    = $90

; *** TIMER-1 ***
.equ  OCR1CH    = $8D
.equ  OCR1CL    = $8C
.equ  OCR1BH    = $8B
.equ  OCR1BL    = $8A
.equ  OCR1AH    = $89
.equ  OCR1AL    = $88
.equ  ICR1H     = $87
.equ  ICR1L     = $86
.equ  TCNT1H    = $85
.equ  TCNT1L    = $84
.equ  TCCR1C    = $82
.equ  TCCR1B    = $81
.equ  TCCR1A    = $80

; *** D.I.D
.equ  DIDR1     = $7F
.equ  DIDR0     = $7E

; ***  A.D.C ***
.equ  ADMUX     = $7C
.equ  ADCSRB    = $7B
.equ  ADCSRA    = $7A
.equ  ADCH      = $79
.equ  ADCL      = $78

; *** XRAM ***
.equ  XMCRB     = $75
.equ  XMCRA     = $74

; *** TIMER INT MASK ***
.equ  TIMSK3    = $71
.equ  TIMSK2    = $70
.equ  TIMSK1    = $6F
.equ  TIMSK0    = $6E

; *** EXTERNAL INT CTRL ***
.equ  EICRB     = $6A
.equ  EICRA     = $69

; *** CLOCK ***
.equ  OSCCAL    = $66
.equ  CLKPR     = $61

; *** WATCHDOG ***
.equ  WDTCR     = $60

; *** MCU ***
.equ  SREG      = $3F
.equ  SPH       = $3E
.equ  SPL       = $3D
.equ  RAMPZ     = $3B
.equ  SPMCSR    = $37
.equ  MCUCR     = $35
.equ  MCUSR     = $34
.equ  SMCR      = $33

; *** O.C.D ***
.equ  OCDR      = $31

; *** ANALOG COMP ***
.equ  ACSR      = $30

; *** S.P.I ***
.equ  SPDR      = $2E
.equ  SPSR      = $2D
.equ  SPCR      = $2C

; *** G.P.I.O ***
.equ  GPIOR2    = $2B
.equ  GPIOR1    = $2A
.equ  GPIOR0    = $1E

; *** TIMER-0 (Sync) ***
.equ  OCR0A     = $27
.equ  TCNT0     = $26
.equ  TCCR0A    = $24

; *** GENERAL TIMER ***
.equ  GTCCR     = $23

; *** EEPROM ***
.equ  EEARH     = $22
.equ  EEARL     = $21
.equ  EEDR      = $20
.equ  EECR      = $1F

; *** EXTERNAL INT MASK ***
.equ  EIMSK     = $1D
.equ  EIFR      = $1C

; *** TIMER INT FLAG ***
.equ  TIFR3     = $18
.equ  TIFR2     = $17
.equ  TIFR1     = $16
.equ  TIFR0     = $15

; *** PORT A upto G ***
.equ  PORTG     = $14
.equ  DDRG      = $13
.equ  PING      = $12
.equ  PORTF     = $11
.equ  DDRF      = $10
.equ  PINF      = $0F
.equ  PORTE     = $0E
.equ  DDRE      = $0D
.equ  PINE      = $0C
.equ  PORTD     = $0B
.equ  DDRD      = $0A
.equ  PIND      = $09
.equ  PORTC     = $08
.equ  DDRC      = $07
.equ  PINC      = $06
.equ  PORTB     = $05
.equ  DDRB      = $04
.equ  PINB      = $03
.equ  PORTA     = $02
.equ  DDRA      = $01
.equ  PINA      = $00

;*****************************************************************************
; Bit Definitions
;*****************************************************************************

; *** CANIDM4 : CAN Identifier Mask 4 Register ***
 .equ RTRMSK = 2
 .equ IDEMSK = 0

; *** CANIDT4 : CAN Identifier Tag 4 Register ***
 .equ RTRTAG = 2
 .equ RB1TAG = 1
 .equ RB0TAG = 0

; *** CANCDMOB : CAN MOB Control Register ***
 .equ CONMOB = 6
 .equ RPLY = 5
 .equ IDE = 4
 .equ DLC = 0

; *** CANSTMOB : CAN MOB Status Register ***
 .equ DLCW = 7
 .equ TXOK = 6
 .equ RXOK = 5
 .equ BERR = 4
 .equ SERR = 3
 .equ CERR = 2
 .equ FERR = 1
 .equ AERR = 0

; *** CANPAGE : CAN MOB Page Register ***
 .equ MOBNB = 4
 .equ AINC = 3
 .equ INDX = 0

; *** CANHPMOB : CAN Highest Priority MOB Register ***
 .equ HPMOB = 4
 .equ CGP = 0

; *** CANBT3: CAN Bit Timing 3 Register ***
 .equ PHS2 = 4
 .equ PHS1 = 1
 .equ SMP = 0

; *** CANBT2: CAN Bit Timing 2 Register ***
 .equ SJW = 5
 .equ PRS = 1

; *** CANBT1: CAN Bit Timing 1 Register ***
 .equ BRP = 1

; *** CANGIE : CAN General Interrupt Enable Register ***
 .equ ENIT = 7
 .equ ENBOFF = 6
 .equ ENRX = 5
 .equ ENTX = 4
 .equ ENERMOB = 3
 .equ ENBUF = 2
 .equ ENERG = 1
 .equ ENOVRT = 0

; *** CANGIT : CAN General Interrupt Register ***
 .equ CANIT = 7
 .equ BOFFIT = 6
 .equ OVRTIM = 5
 .equ OVRBUF = 4
 .equ SERG = 3
 .equ CERG = 2
 .equ FERG = 1
 .equ AERG = 0

; *** CANGSTA : CAN General Status Register ***
 .equ OVFG = 6
 .equ TXBSY = 4
 .equ RXBSY = 3
 .equ ENFG = 2
 .equ BOFF = 1
 .equ ERRP = 0

; *** CANGCON : CAN General Control Register ***
 .equ ABRQ = 7
 .equ OVRQ = 6
 .equ TTC = 5
 .equ SYNCTTC = 4
 .equ LISTEN = 3
 .equ ENA = 1
 .equ SWRES = 0

; *** UCSR1C : USART1 Control and Status Register C ***
 .equ UMSEL1 = 6
 .equ UPM11 = 5
 .equ UPM10 = 4
 .equ USBS1 = 3
 .equ UCSZ11 = 2
 .equ UCSZ10 = 1
 .equ UCPOL1 = 0

; *** UCSR1B : USART1 Control and Status Register B ***
 .equ RXCIE1 = 7
 .equ TXCIE1 = 6
 .equ UDRIE1 = 5
 .equ RXEN1 = 4
 .equ TXEN1 = 3
 .equ UCSZ12 = 2
 .equ RXB81 = 1
 .equ TXB81 = 0

; *** UCSR1A : USART1 Control and Status Register A ***
 .equ RXC1 = 7
 .equ TXC1 = 6
 .equ UDRE1 = 5
 .equ FE1 = 4
 .equ DOR1 = 3
 .equ UPE1 = 2
 .equ U2X1 = 1
 .equ MPCM1 = 0

; *** UCSR0C : USART0 Control and Status Register C ***
 .equ UMSEL0 = 6
 .equ UPM01 = 5
 .equ UPM00 = 4
 .equ USBS0 = 3
 .equ UCSZ01 = 2
 .equ UCSZ00 = 1
 .equ UCPOL0 = 0

; *** UCSR0B : USART0 Control and Status Register B ***
 .equ RXCIE0 = 7
 .equ TXCIE0 = 6
 .equ UDRIE0 = 5
 .equ RXEN0 = 4
 .equ TXEN0 = 3
 .equ UCSZ02 = 2
 .equ RXB80 = 1
 .equ TXB80 = 0

; *** UCSR0A : USART0 Control and Status Register A ***
 .equ RXC0 = 7
 .equ TXC0 = 6
 .equ UDRE0 = 5
 .equ FE0 = 4
 .equ DOR0 = 3
 .equ UPE0 = 2
 .equ U2X0 = 1
 .equ MPCM0 = 0

; *** TWCR : TWI Control Register ***
 .equ TWINT = 7
 .equ TWEA = 6
 .equ TWSTA = 5
 .equ TWSTO = 4
 .equ TWWC = 3
 .equ TWEN = 2
 .equ TWIE = 0

; *** TWAR : TWI (slave) Address Register ****
 .equ TWA6 = 7
 .equ TWA5 = 6
 .equ TWA4 = 5
 .equ TWA3 = 4
 .equ TWA2 = 3
 .equ TWA1 = 2
 .equ TWA0 = 1
 .equ TWGCE = 0

; *** TWSR : TWI Status Register ***
 .equ TWS7 = 7
 .equ TWS6 = 6
 .equ TWS5 = 5
 .equ TWS4 = 4
 .equ TWS3 = 3
 .equ TWPS1 = 1
 .equ TWPS0 = 0

; *** ASSR : Timer-2 Asynchronous Mode Status Register ***
 .equ EXCLK = 4
 .equ AS2 = 3
 .equ TCN2UB = 2
 .equ OCR2UB = 1
 .equ TCR2UB = 0

; *** TCCR2A : Timer/Counter 2 Control Register A  ***
 .equ FOC2 = 7
 .equ WGM20 = 6
 .equ COM2A1 = 5
 .equ COM2A0 = 4
 .equ WGM21 = 3
 .equ CS22 = 2
 .equ CS21 = 1
 .equ CS20 = 0

; *** TCCR3C : Timer/Counter 3 Control Register C ***
 .equ FOC3A = 7
 .equ FOC3B = 6
 .equ FOC3C = 5

; *** TCCR3B : Timer/Counter 3 Control Register B ***
 .equ ICNC3 = 7
 .equ ICES3 = 6
 .equ WGM33 = 4
 .equ WGM32 = 3
 .equ CS32 = 2
 .equ CS31 = 1
 .equ CS30 = 0

; *** TCCR3A : Timer/Counter 3 Control Register A ***
 .equ COM3A1 = 7
 .equ COM3A0 = 6
 .equ COM3B1 = 5
 .equ COM3B0 = 4
 .equ COM3C1 = 3
 .equ COM3C0 = 2
 .equ WGM31 = 1
 .equ WGM30 = 0

; *** TCCR1C : Timer/Counter 1 Control Register C ***
 .equ FOC1A = 7
 .equ FOC1B = 6
 .equ FOC1C = 5

; *** TCCR1B : Timer/Counter 1 Control Register B ***
 .equ ICNC1 = 7
 .equ ICES1 = 6
 .equ WGM13 = 4
 .equ WGM12 = 3
 .equ CS12 = 2
 .equ CS11 = 1
 .equ CS10 = 0

; *** TCCR1A : Timer/Counter 1 Control Register A ***
 .equ COM1A1 = 7
 .equ COM1A0 = 6
 .equ COM1B1 = 5
 .equ COM1B0 = 4
 .equ COM1C1 = 3
 .equ COM1C0 = 2
 .equ WGM11 = 1
 .equ WGM10 = 0

; *** DIDR0 : Digital Input Disable Register 0 ***
 .equ ADC7D = 7
 .equ ADC6D = 6
 .equ ADC5D = 5
 .equ ADC4D = 4
 .equ ADC3D = 3
 .equ ADC2D = 2
 .equ ADC1D = 1
 .equ ADC0D = 0

; *** DIDR1 : Digital Input Disable Register 1 ***
 .equ AIN1D = 1
 .equ AIN0D = 0

; *** ADMUX : ADC Multiplexer Selection Register ***
 .equ REFS1 = 7
 .equ REFS0 = 6
 .equ ADLAR = 5
 .equ MUX4 = 4
 .equ MUX3 = 3
 .equ MUX2 = 2
 .equ MUX1 = 1
 .equ MUX0 = 0

; *** ADCSRB : ADC Control and Status Register B ***
 .equ ADHSM = 7
 .equ ACME = 6
 .equ ADTS2 = 2
 .equ ADTS1 = 1
 .equ ADTS0 = 0

; *** ADCSRA : ADC Control and Status Register A ***
 .equ ADEN = 7
 .equ ADSC = 6
 .equ ADRF = 5
 .equ ADIF = 4
 .equ ADIE = 3
 .equ ADPS2 = 2
 .equ ADPS1 = 1
 .equ ADPS0 = 0

; *** XMCRB : External Memory Control B Register ***
 .equ XMBK = 7
 .equ XMM2 = 2
 .equ XMM1 = 1
 .equ XMM0 = 0

; *** XMCRA : External Memory Control A Register ***
 .equ SRE = 7
 .equ SRL2 = 6
 .equ SRL1 = 5
 .equ SRL0 = 4
 .equ SRW11 = 3
 .equ SRW10 = 2
 .equ SRW01 = 1
 .equ SRW00 = 0

; *** TIMSK3 : Timer Interrupt Mask Register3 ***
 .equ ICIE3 = 5
 .equ OCIE3C = 3
 .equ OCIE3B = 2
 .equ OCIE3A = 1
 .equ TOIE3 = 0

; *** TIMSK2 : Timer Interrupt Mask Register2 ***
 .equ OCIE2A = 1
 .equ TOIE2 = 0

; *** TIMSK1 : Timer Interrupt Mask Register1 ***
 .equ ICIE1 = 5
 .equ OCIE1C = 3
 .equ OCIE1B = 2
 .equ OCIE1A = 1
 .equ TOIE1 = 0

; *** TIMSK0 : Timer Interrupt Mask Register0 ***
 .equ OCIE0A = 1
 .equ TOIE0 = 0

; *** EICRB : External Interrupt Control B Register ***
 .equ ISC71 = 7
 .equ ISC70 = 6
 .equ ISC61 = 5
 .equ ISC60 = 4
 .equ ISC51 = 3
 .equ ISC50 = 2
 .equ ISC41 = 1
 .equ ISC40 = 0

; *** EICRA : External Interrupt Control A Register  ***
 .equ ISC31 = 7
 .equ ISC30 = 6
 .equ ISC21 = 5
 .equ ISC20 = 4
 .equ ISC11 = 3
 .equ ISC10 = 2
 .equ ISC01 = 1
 .equ ISC00 = 0

; *** OSCCAL : Internal Oscillator Calibration Register ***
 .equ CAL6 = 6
 .equ CAL5 = 5
 .equ CAL4 = 4
 .equ CAL3 = 3
 .equ CAL2 = 2
 .equ CAL1 = 1
 .equ CAL0 = 0

; *** CLKPR : Source Clock Prescaler Register ***
 .equ CLKPCE = 7
 .equ CLKPS3 = 3
 .equ CLKPS2 = 2
 .equ CLKPS1 = 1
 .equ CLKPS0 = 0

; *** WDTCR : Watchdog Timer Control Register ***
 .equ WDCE = 4
 .equ WDE = 3
 .equ WDP2 = 2
 .equ WDP1 = 1
 .equ WDP0 = 0

; *** SREG : MCU Status Register ***
 .equ I = 7
 .equ T = 6
 .equ H = 5
 .equ S = 4
 .equ V = 3
 .equ N = 2
 .equ Z = 1
 .equ C = 0

; *** SPH : Stack Pointer High ***
 .equ SP15 = 7
 .equ SP14 = 6
 .equ SP13 = 5
 .equ SP12 = 4
 .equ SP11 = 3
 .equ SP10 = 2
 .equ SP9 = 1
 .equ SP8 = 0

; *** SPL : Stack Pointer Low ***
 .equ SP7 = 7
 .equ SP6 = 6
 .equ SP5 = 5
 .equ SP4 = 4
 .equ SP3 = 3
 .equ SP2 = 2
 .equ SP1 = 1
 .equ SP0 = 0

; *** RAMPZ : RAM Page Z Select Register ***
 .equ RAMPZ0 = 0

; *** SPMCSR : Store Program Memory Control and Status Register ***
 .equ SPMIE = 7
 .equ RWWSB = 6
 .equ RWWSRE = 4
 .equ BLBSET = 3
 .equ PGWRT = 2
 .equ PGERS = 1
 .equ SPMEN = 0

; *** MCUCR : MCU general Control Register ***
 .equ JTD = 7
 .equ PUD = 4
 .equ IVSEL = 1
 .equ IVCE = 0

; *** MCUSR : MCU general Status Register ***
 .equ JTRF = 4
 .equ WDRF = 3
 .equ BORF = 2
 .equ EXTRF = 1
 .equ PORF = 0

; *** SMCR : Sleep Mode Control Register ***
 .equ SM2 = 3
 .equ SM1 = 2
 .equ SM0 = 1
 .equ SE = 0

; *** OCDR : On-Chip Debug Register ***
 .equ IDRD = 7
 .equ OCDR7 = 7
 .equ OCDR6 = 6
 .equ OCDR5 = 5
 .equ OCDR4 = 4
 .equ OCDR3 = 3
 .equ OCDR2 = 2
 .equ OCDR1 = 1
 .equ OCDR0 = 0

; *** ACSR : Analog Comparator Control and Status Register ***
 .equ ACD = 7
 .equ ACBG = 6
 .equ ACO = 5
 .equ ACI = 4
 .equ ACIE = 3
 .equ ACIC = 2
 .equ ACIS1 = 1
 .equ ACIS0 = 0

; *** SPSR : SPI Status Register ***
 .equ SPIF = 7
 .equ WCOL = 6
 .equ SPI2X = 0

; *** SPCR : SPI Control Register ***
 .equ SPIE = 7
 .equ SPE = 6
 .equ DORD = 5
 .equ MSTR = 4
 .equ CPOL = 3
 .equ CPHA = 2
 .equ SPR1 = 1
 .equ SPR0 = 0

; *** TCCR0A : Timer/Counter 0 Control Register ***
 .equ FOC0A = 7
 .equ WGM00 = 6
 .equ COM0A1 = 5
 .equ COM0A0 = 4
 .equ WGM01 = 3
 .equ CS02 = 2
 .equ CS01 = 1
 .equ CS00 = 0

; *** GTCCR : General Timer Control Register ***
 .equ TSM = 7
 .equ PSR2 = 1
 .equ PSR310 = 0

; To make tim8pwm_def.inc file part independent.
 .equ PSR0 = PSR310
 .equ PSR1 = PSR310
 .equ PSR3 = PSR310

; *** EECR : EEPROM Control Register ***
 .equ EERIE = 3
 .equ EEMWE = 2
 .equ EEWE = 1
 .equ EERE = 0

; *** GPIOR0 : General Purpose I/O Register 0 ***
 .equ GPIOR07 = 7
 .equ GPIOR06 = 6
 .equ GPIOR05 = 5
 .equ GPIOR04 = 4
 .equ GPIOR03 = 3
 .equ GPIOR02 = 2
 .equ GPIOR01 = 1
 .equ GPIOR00 = 0

; *** EIMSK : External Interrupt Mask Register ***
 .equ INT7 = 7
 .equ INT6 = 6
 .equ INT5 = 5
 .equ INT4 = 4
 .equ INT3 = 3
 .equ INT2 = 2
 .equ INT1 = 1
 .equ INT0 = 0

; *** EIFR : External Interrupt Flag Register ***
 .equ INTF7 = 7
 .equ INTF6 = 6
 .equ INTF5 = 5
 .equ INTF4 = 4
 .equ INTF3 = 3
 .equ INTF2 = 2
 .equ INTF1 = 1
 .equ INTF0 = 0

; *** TIFR3 : Timer/Counter Interrupt Flag Register 3 ***
 .equ ICF3 = 5
 .equ OCF3C = 3
 .equ OCF3B = 2
 .equ OCF3A = 1
 .equ TOV3 = 0

; *** TIFR2 : Timer/Counter Interrupt Flag Register 2 ***
 .equ OCF2A = 1
 .equ TOV2 = 0

; *** TIFR1 : Timer/Counter Interrupt Flag Register 1 ***
 .equ ICF1 = 5
 .equ OCF1C = 3
 .equ OCF1B = 2
 .equ OCF1A = 1
 .equ TOV1 = 0

; *** TIFR0 : Timer/Counter Interrupt Flag Register 0 ***
 .equ OCF0A = 1
 .equ TOV0 = 0

; *** PORTG : Data Register, Port G ***
 .equ PORTG4 = 4
 .equ PORTG3 = 3
 .equ PORTG2 = 2
 .equ PORTG1 = 1
 .equ PORTG0 = 0
 .equ PG4 = 4
 .equ PG3 = 3
 .equ PG2 = 2
 .equ PG1 = 1
 .equ PG0 = 0

; *** DDRG : Data Direction Register, Port G ***
 .equ DDG4 = 4
 .equ DDG3 = 3
 .equ DDG2 = 2
 .equ DDG1 = 1
 .equ DDG0 = 0

; *** PING : Input Pin Register, Port G ***
 .equ PING5 = 5
 .equ PING4 = 4
 .equ PING3 = 3
 .equ PING2 = 2
 .equ PING1 = 1
 .equ PING0 = 0

; *** PORTF : Data Register, Port F ***
 .equ PORTF7 = 7
 .equ PORTF6 = 6
 .equ PORTF5 = 5
 .equ PORTF4 = 4
 .equ PORTF3 = 3
 .equ PORTF2 = 2
 .equ PORTF1 = 1
 .equ PORTF0 = 0
 .equ PF7 = 7
 .equ PF6 = 6
 .equ PF5 = 5
 .equ PF4 = 4
 .equ PF3 = 3
 .equ PF2 = 2
 .equ PF1 = 1
 .equ PF0 = 0

; *** DDRF : Data Direction Register, Port F ***
 .equ DDF7 = 7
 .equ DDF6 = 6
 .equ DDF5 = 5
 .equ DDF4 = 4
 .equ DDF3 = 3
 .equ DDF2 = 2
 .equ DDF1 = 1
 .equ DDF0 = 0

; *** PINF : Input Pin Register, Port F ***
 .equ PINF7 = 7
 .equ PINF6 = 6
 .equ PINF5 = 5
 .equ PINF4 = 4
 .equ PINF3 = 3
 .equ PINF2 = 2
 .equ PINF1 = 1
 .equ PINF0 = 0

; *** PORTE : Data Register, Port E ***
 .equ PORTE7 = 7
 .equ PORTE6 = 6
 .equ PORTE5 = 5
 .equ PORTE4 = 4
 .equ PORTE3 = 3
 .equ PORTE2 = 2
 .equ PORTE1 = 1
 .equ PORTE0 = 0
 .equ PE7 = 7
 .equ PE6 = 6
 .equ PE5 = 5
 .equ PE4 = 4
 .equ PE3 = 3
 .equ PE2 = 2
 .equ PE1 = 1
 .equ PE0 = 0

; *** DDRE : Data Direction Register, Port E ***
 .equ DDE7 = 7
 .equ DDE6 = 6
 .equ DDE5 = 5
 .equ DDE4 = 4
 .equ DDE3 = 3
 .equ DDE2 = 2
 .equ DDE1 = 1
 .equ DDE0 = 0

; *** PINE : Input Pin Register, Port E ***
 .equ PINE7 = 7
 .equ PINE6 = 6
 .equ PINE5 = 5
 .equ PINE4 = 4
 .equ PINE3 = 3
 .equ PINE2 = 2
 .equ PINE1 = 1
 .equ PINE0 = 0

; *** PORTD : Data Register, Port D ***
 .equ PORTD7 = 7
 .equ PORTD6 = 6
 .equ PORTD5 = 5
 .equ PORTD4 = 4
 .equ PORTD3 = 3
 .equ PORTD2 = 2
 .equ PORTD1 = 1
 .equ PORTD0 = 0
 .equ PD7 = 7
 .equ PD6 = 6
 .equ PD5 = 5
 .equ PD4 = 4
 .equ PD3 = 3
 .equ PD2 = 2
 .equ PD1 = 1
 .equ PD0 = 0

; *** DDRD : Data Direction Register, Port D ***
 .equ DDD7 = 7
 .equ DDD6 = 6
 .equ DDD5 = 5
 .equ DDD4 = 4
 .equ DDD3 = 3
 .equ DDD2 = 2
 .equ DDD1 = 1
 .equ DDD0 = 0

; *** PIND : Input Pin Register, Port D ***
 .equ PIND7 = 7
 .equ PIND6 = 6
 .equ PIND5 = 5
 .equ PIND4 = 4
 .equ PIND3 = 3
 .equ PIND2 = 2
 .equ PIND1 = 1
 .equ PIND0 = 0

; *** PORTC : Data Register, Port C ***
 .equ PORTC7 = 7
 .equ PORTC6 = 6
 .equ PORTC5 = 5
 .equ PORTC4 = 4
 .equ PORTC3 = 3
 .equ PORTC2 = 2
 .equ PORTC1 = 1
 .equ PORTC0 = 0
 .equ PC7 = 7
 .equ PC6 = 6
 .equ PC5 = 5
 .equ PC4 = 4
 .equ PC3 = 3
 .equ PC2 = 2
 .equ PC1 = 1
 .equ PC0 = 0

; *** DDRC : Data Direction Register, Port C ***
 .equ DDC7 = 7
 .equ DDC6 = 6
 .equ DDC5 = 5
 .equ DDC4 = 4
 .equ DDC3 = 3
 .equ DDC2 = 2
 .equ DDC1 = 1
 .equ DDC0 = 0

; *** PINC : Input Pin Register, Port C ***
 .equ PINC7 = 7
 .equ PINC6 = 6
 .equ PINC5 = 5
 .equ PINC4 = 4
 .equ PINC3 = 3
 .equ PINC2 = 2
 .equ PINC1 = 1
 .equ PINC0 = 0

; *** PORTB : Data Register, Port B ***
 .equ PORTB7 = 7
 .equ PORTB6 = 6
 .equ PORTB5 = 5
 .equ PORTB4 = 4
 .equ PORTB3 = 3
 .equ PORTB2 = 2
 .equ PORTB1 = 1
 .equ PORTB0 = 0
 .equ PB7 = 7
 .equ PB6 = 6
 .equ PB5 = 5
 .equ PB4 = 4
 .equ PB3 = 3
 .equ PB2 = 2
 .equ PB1 = 1
 .equ PB0 = 0

; *** DDRB : Data Direction Register, Port B ***
 .equ DDB7 = 7
 .equ DDB6 = 6
 .equ DDB5 = 5
 .equ DDB4 = 4
 .equ DDB3 = 3
 .equ DDB2 = 2
 .equ DDB1 = 1
 .equ DDB0 = 0

; *** PINB : Input Pin Register, Port B ***
 .equ PINB7 = 7
 .equ PINB6 = 6
 .equ PINB5 = 5
 .equ PINB4 = 4
 .equ PINB3 = 3
 .equ PINB2 = 2
 .equ PINB1 = 1
 .equ PINB0 = 0

; *** PORTA : Data Register, Port A ***
 .equ PORTA7 = 7
 .equ PORTA6 = 6
 .equ PORTA5 = 5
 .equ PORTA4 = 4
 .equ PORTA3 = 3
 .equ PORTA2 = 2
 .equ PORTA1 = 1
 .equ PORTA0 = 0
 .equ PA7 = 7
 .equ PA6 = 6
 .equ PA5 = 5
 .equ PA4 = 4
 .equ PA3 = 3
 .equ PA2 = 2
 .equ PA1 = 1
 .equ PA0 = 0

; *** DDRA : Data Direction Register, Port A ***
 .equ DDA7 = 7
 .equ DDA6 = 6
 .equ DDA5 = 5
 .equ DDA4 = 4
 .equ DDA3 = 3
 .equ DDA2 = 2
 .equ DDA1 = 1
 .equ DDA0 = 0

; *** PINA : Input Pin Register, Port A ***
 .equ PINA7 = 7
 .equ PINA6 = 6
 .equ PINA5 = 5
 .equ PINA4 = 4
 .equ PINA3 = 3
 .equ PINA2 = 2
 .equ PINA1 = 1
 .equ PINA0 = 0

;*****************************************************************************
; CPU Register Declarations
;*****************************************************************************

;.def  XL        = r26        ; X pointer Low
;.def  XH        = r27        ; X pointer High
;.def  YL        = r28        ; Y pointer Low
;.def  YH        = r29        ; Y pointer High
;.def  ZL        = r30        ; Z pointer Low
;.def  ZH        = r31        ; Z pointer High

;*****************************************************************************
; Data Memory Declarations
;*****************************************************************************

.equ  IOEND     = $00FF      ; 256 bytes I/O + REG
.equ  RAMSIZE   = $1000      ; 4K byte RAM

 .equ RAMEND = IOEND+RAMSIZE ;($10FF) Highest internal data memory (SRAM) add.
                             ;(4k bytes RAM + I/O + REG)
.equ  EEPROMEND = $0FFF      ; Highest EEPROM address.
                             ;(4k bytes)

 .equ EEADRBITS = 12         ; no. of bits in EEPROM address register

;*****************************************************************************
; Program Memory Declarations
;*****************************************************************************

.equ  FLASHEND  = $FFFF      ;  Highest program memory (Flash) address
                             ; (When addressed as 16-bit words)
                             ; ( 64k words , 128k bytes )

;**** Boot Vectors ****
 .equ SMALLBOOTSTART = 0b1111111000000000 ; ($FE00) Smallest boot block is 51
 .equ SECONDBOOTSTART = 0b1111110000000000 ; ($FC00) 2'nd boot block size is 1
 .equ THIRDBOOTSTART = 0b1111100000000000 ; ($F800) 3'rd boot block size is 2
 .equ LARGEBOOTSTART = 0b1111000000000000 ; ($F000) Largest boot block is 4KW

;**** Page Size ****
 .equ PAGESIZE = 128   ; number of WORDS in a Flash page
 .equ EEPAGESIZE = 8     ; number of BYTES in an EEPROM page

;**** Interrupt Vectors ****
;.equ RESETaddr     = $000   ; RESET Vector Address
.equ  INT0addr      = $002   ; External Interrupt0 Vector Address
.equ  INT1addr      = $004   ; External Interrupt1 Vector Address
.equ  INT2addr      = $006   ; External Interrupt2 Vector Address
.equ  INT3addr      = $008   ; External Interrupt3 Vector Address
.equ  INT4addr      = $00A   ; External Interrupt4 Vector Address
.equ  INT5addr      = $00C   ; External Interrupt5 Vector Address
.equ  INT6addr      = $00E   ; External Interrupt6 Vector Address
.equ  INT7addr      = $010   ; External Interrupt7 Vector Address
.equ  OC2addr       = $012   ; Timer/Counter2 Compare Match Interrupt Address
.equ  OVF2addr      = $014   ; Timer/Counter2 Overflow Interrupt Address
.equ  ICP1addr      = $016   ; Timer/Counter1 Input Capture Interrupt Address
.equ  OC1Aaddr      = $018   ; Timer/Counter1 Output CompareA Interrupt Addres
.equ  OC1Baddr      = $01A   ; Timer/Counter1 Output CompareB Interrupt Addres
.equ  OC1Caddr      = $01C   ; Timer/Counter1 Output CompareC Interrupt Addres
.equ  OVF1addr      = $01E   ; Timer/Counter1 Overflow Interrupt Address
.equ  OC0addr       = $020   ; Timer/Counter0 Compare Match Interrupt Address
.equ  OVF0addr      = $022   ; Timer/Counter0 Overflow Interrupt Address
.equ  CANITaddr     = $024   ; CAN Transfer Complete or Error Address
.equ  OVRITaddr     = $026   ; CAN Timer Overrun Address
.equ  SPIaddr       = $028   ; SPI Interrupt Address
.equ  URXC0addr     = $02A   ; USART-0 Receive Complete Interrupt Address
.equ  UDRE0addr     = $02C   ; USART-0 Data Register Empty Interrupt Address
.equ  UTXC0addr     = $02E   ; USART-0 Transmit Complete Interrupt Address
.equ  ACIaddr       = $030   ; Analog Comparator Interrupt Address
.equ  ADCCaddr      = $032   ; ADC Conversion Complete Interrupt Address
.equ  ERDYaddr      = $034   ; EEPROM Write Complete Interrupt Address
.equ  ICP3addr      = $036   ; Timer/Counter3 Input Capture Interrupt Address
.equ  OC3Aaddr      = $038   ; Timer/Counter3 Output CompareA Interrupt Addres
.equ  OC3Baddr      = $03A   ; Timer/Counter3 Output CompareB Interrupt Addres
.equ  OC3Caddr      = $03C   ; Timer/Counter3 Output CompareC Interrupt Addres
.equ  OVF3addr      = $03E   ; Timer/Counter3 Overflow Interrupt Address
.equ  URXC1addr     = $040   ; USART-1 Receive Complete Interrupt Address
.equ  UDRE1addr     = $042   ; USART-1 Data Register Empty Interrupt Address
.equ  UTXC1addr     = $044   ; USART-1 Transmit Complete Interrupt Address
.equ  TWIaddr       = $046   ; TWI Interrupt Vector Address
.equ  SPMRaddr      = $048   ; Store Program Memory Ready Interrupt Address

;**** End of File ****

 SetAsmDefinitions:

    ret
 .endif
;-------------------------------------------------
